/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('estratecmslink', 'en,de,sv,zh_cn,cs,fa,fr_ca,fr,pl,pt_br,nl,he,no');

function TinyMCE_estratecmslink_getInfo() {
	return {
		longname : 'Estratecms link plugin',
		author : 'Email Communications',
		authorurl : 'http://www.emailcommunications.nl/',
		infourl : 'http://www.estratecms.org/',
		version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
	};
};

function TinyMCE_estratecmslink_getControlHTML(control_name) {
	
	switch (control_name) {
		
		case "link":
			return '<a href="javascript:tinyMCE.execInstanceCommand(\'{$editor_id}\',\'mceestratecmslink\');" target="_self" onmousedown="return false;"><img id="{$editor_id}_estratecmslink" src="{$themeurl}/images/link.gif" title="{$lang_image_desc}" width="20" height="20" class="mceButtonNormal" onmouseover="tinyMCE.switchClass(this,\'mceButtonOver\');" onmouseout="tinyMCE.restoreClass(this);" onmousedown="tinyMCE.restoreClass(this);" /></a>';
	}

	return "";
}

function TinyMCE_estratecmslink_execCommand(editor_id, element, command, user_interface, value) {
	switch (command) {
		case "mceestratecmslink":
			var template = new Array();

			template['file']   = tinyMCE.settings['path']+'/link.php?item_language='+tinyMCE.settings['item_language'];
			template['width']  = 700;
			template['height'] = 380;

			// Language specific width and height addons
			template['width']  += tinyMCE.getLang('lang_estratecmslink_delta_width', 0);
			template['height'] += tinyMCE.getLang('lang_estratecmslink_delta_height', 0);

			tinyMCE.openWindow(template, {editor_id : editor_id, inline : "yes", scrollbars:"yes"});

			return true;
	}

	return false;
}

function TinyMCE_estratecmslink_cleanup(type, content) {


	return content;
}

function TinyMCE_estratecmslink_handleNodeChange(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (node == null)
			return;

		do {
			if (node.nodeName == "HR") {
				tinyMCE.switchClass(editor_id + '_estratecmslink', 'mceButtonSelected');
				return true;
			}
		} while ((node = node.parentNode));

		tinyMCE.switchClass(editor_id + '_estratecmslink', 'mceButtonNormal');

		return true;
	}