<?php
ini_set("include_path",ini_get("include_path").":".$GLOBALS['lib_path'] );

//timing script execution for code optimalisation
if( 1==1 && function_exists('memory_get_usage') ) {
    $resources = getrusage();
    define( 'CMS_EXECUTION_USERTIME', sprintf( "%d.%06d", $resources["ru_utime.tv_sec"], $resources["ru_utime.tv_usec"] ) );
    define( 'CMS_EXECUTION_SYSTEMTIME', sprintf( "%d.%06d", $resources["ru_stime.tv_sec"], $resources["ru_stime.tv_usec"] ) );
    define( 'PHPUSAGE',memory_get_usage());
}

define( 'MODULE_CMS', TRUE );
//You are prohibited to edit the line below and to remove or edit the generator meta-tag in the site's header.
define( 'CMS_GENERATOR', 'Opensourcecms.eu v4.0 Dev VERSION' );
define('OSC_SECURE',1);

/* waar hack definieren?? 

probeer dir te vinden

*/

//require_once('config.php' );

if(defined('HACK_BASE_URL'))require_once($_SERVER['DOCUMENT_ROOT'].HACK_BASE_URL.'config.php');
else
{
/*
19 / 03 / 2007 
$_SERVER['PHP_SELF'] vervangen door $_SERVER['REQUEST_URI'];
ivm googlemaps en subdirs
*/
if(preg_match('/\/$/',$_SERVER['REQUEST_URI']) && file_exists($_SERVER['DOCUMENT_ROOT'].$_SERVER['REQUEST_URI'].'config.php'))require_once($_SERVER['DOCUMENT_ROOT'].$_SERVER['REQUEST_URI'].'config.php');
elseif(file_exists(dirname($_SERVER['DOCUMENT_ROOT'].'/'.substr($_SERVER['REQUEST_URI'],1)).'/config.php'))require_once(dirname($_SERVER['DOCUMENT_ROOT'].'/'.substr($_SERVER['REQUEST_URI'],1)).'/config.php');
elseif(file_exists(dirname($_SERVER['DOCUMENT_ROOT'].'/'.substr($_SERVER['PHP_SELF'],1)).'/config.php'))require_once(dirname($_SERVER['DOCUMENT_ROOT'].'/'.substr($_SERVER['PHP_SELF'],1)).'/config.php');
else if(file_exists($_SERVER['DOCUMENT_ROOT'].'/config.php'))require_once($_SERVER['DOCUMENT_ROOT'].'/config.php');
else require_once('config.php' );
}
/*require_once('db.php');
require_once('io.php');
require_once('mm.php');
require_once('cmsmodules/cmsmodules.php');
require_once 'cmsconfig/cmsconfig.php';*/
require_once('myautoload.php');

require_once 'db.php';
require_once 'io.php';
require_once 'mm.php';
require_once 'cmsconfig/cmsconfig.php';
/*require_once 'cmsmodules/cmsmodules.php';
require_once 'cmsusers/cmsusers.php';
require_once 'cmsglue/cmsglue.php';
require_once 'cmslanguages/cmslanguages.php';
require_once 'cmsstructure/cmsstructure.php';
require_once 'cmstemplates/cmstemplates.php';*/




/* Class CMS is the main class of the FastCows Content Management System
   It connects all the other classes, tables, templates together.*/
class cms
{
	var	$_db;			//link to DB connection object
	var	$_acl;			//link to acl structure
	//var	$_url;			//url of current page (without base url) starts and ends with a slash
	var	$_strucid;		//structure id of current page
	//var	$_url_input;		//if last part of url is a number ie. /nl/latest-news/10/, this var contains that number
	var	$_currentuser;		//object of current user
	var	$_extraheaders;		//mainly used for WYSIWYG editors and other javascript
	var	$_path_ids;		//array of path id's to page in structure
	var	$_path;
	var $glue;
	var $cfg;
	var $menu;
	var $struc;
	var $lastmodified;
	/*function cms( &$cfg, $header=true )
	{
		if( !isset( $cfg['lib_path'] ) ) {
			$cfg['lib_path'] = cleanDirectory( dirname(__FILE__) );
		}
		if( !isset( $cfg['client_path'] ) ) {
			$cfg['client_path'] = cleanDirectory( getcwd() );
		}
		if( !isset( $cfg['config_path'] ) ) {
			$cfg['config_path'] = cleanDirectory( $cfg['client_path'] . 'conf/' );
		}
		if( isset( $cfg['debug'] ) && $cfg['debug'] ) {
			ini_set( 'error_reporting', E_ALL );
			ini_set( 'display_errors', TRUE );
		} else {
			$cfg['debug'] = 0;
			ini_set( 'display_errors', FALSE );
		}
		$this->connect( $cfg );
		unset( $cfg['db_password'] );
		cleanGlobals();
		cmsmodules::loadModules($cfg);
		cmsconfig::setGlobals($cfg);
		
		$this->cfg=$cfg;
		
		if($header)header('Content-type: text/html; charset=utf-8');
	}
	
	*/
	
	function cms( &$cfg )
    {
        
    	//error_reporting(E_ALL | E_STRICT);
    	
    	error_reporting(E_ALL);
      	
    	if( !isset( $cfg['lib_path'] ) ) {
            $cfg['lib_path'] = cleanDirectory( dirname(__FILE__) );
        }

        cmsconfig::setGlobals( $cfg );
        
        if(defined('CMS_LOG') && CMS_LOG==1)
        {
        	ini_set('log_errors',true);
        	ini_set('error_log',$cfg['lib_path'].'errors.log');
        }	
        
        /* 
        
        basismodules laden 
        creeer de mogelijkheid om elke module per site te kunnen laden
        
        */

        
        foreach (array('cmsmodules','cmsusers','cmsglue','cmslanguages','cmsstructure','cmstemplates') as $module)
        {
            if(file_exists(CMS_CLIENT_PATH.'modules/'.$module.'/'.$module.'.php'))
        	{
        		require_once CMS_CLIENT_PATH.'modules/'.$module.'/'.$module.'.php';
        	}	
        	else 
        	{
        		require_once $module.'/'.$module.'.php';
        	}
            	
        }	

       
        
        
        switch( $cfg['db_type'] ) {
            default:
            case 'mysql':
                require_once 'db_mysql.php';
            break;
        }
        $this->_db = new db( $cfg );
        if( $this->_db ) {
            unset( $cfg );
            cleanGlobals();
            cmsmodules::loadModules();
        } elseif( CMS_DEBUG ) {
            die( 'Database connection failed.' );
        } else {
            return FALSE;
        }
        
       
        
    }

	
	/*function connect( $dbdata )
	{
		if( is_array( $dbdata ) && $dbdata['db_username'] <> 'root' && $dbdata['db_password'] ) {
			$this->_db = &ADONewConnection( $dbdata['db_type'] );
			if( $dbdata['debug'] > 1) {
				$this->_db->debug = TRUE;
			}
			$this->_db->Connect( $dbdata['db_host'], $dbdata['db_username'], $dbdata['db_password'], $dbdata['db_database'] );
			echo $this->_db->ErrorMsg();
			return $this->_db->SetFetchMode( ADODB_FETCH_ASSOC );
		} else {
			return FALSE;
		}
	}*/


	
	function site_user_info()
	{
		    $this->getUrl();

			CMSLanguages::loadTranslation( CMS_OVERRULED_LANGUAGE ? CMS_OVERRULED_LANGUAGE: CMS_CURRENT_LANGUAGE );

			$this->_currentuser = new cmsusers($this->_db);
			$this->_currentuser->login();

			$this->struc = new cmsstructure($this->_db);
			if(defined('structid'))
			{
			define( 'CMS_STRUCTURE_ID', defined('SUBSITEIDOVERRULED')?SUBSITEIDOVERRULED:structid );
			$this->struc->load( defined('SUBSITEIDOVERRULED')?SUBSITEIDOVERRULED:structid );

			}
			/* voor compatibliteit */
			elseif( $strucid = $this->struc->loadByURL( CMS_CURRENT_URL ) ) {
				
				define( 'CMS_STRUCTURE_ID', $strucid );
			} else {
				$this->struc->load( CMS_DEFAULT_PAGE );
				define( 'CMS_STRUCTURE_ID', $this->struc->id );
			}
			
			$this->lastmodified = $this->struc->update_time;

			if( $this->_currentuser->hasRights( $this->struc->requiredrights ) ) {
				define( 'CMS_USER_HASRIGHTS', TRUE );
			} else {
				define( 'CMS_USER_HASRIGHTS', false );
			}
			
			if(isset($this->struc->_long_turls[CMS_CURRENT_LANGUAGE]))$this->_url = CMS_BASE_URL.CMS_CURRENT_LANGUAGE.$this->struc->_long_turls[CMS_CURRENT_LANGUAGE];
			
			if( CMS_STRUCTURE_ID ) {
				/*if( isset( $this->struc->_titles[ CMS_CURRENT_LANGUAGE ] ) && CMS_STRUCTURE_ID<>CMS_DEFAULT_PAGE ) {
					define( 'CMS_TITLE', CMS_DEFAULT_TITLE.' - '.$this->struc->_titles[ CMS_CURRENT_LANGUAGE ] );
				} else {
					define( 'CMS_TITLE', CMS_DEFAULT_TITLE );
				}
				$this->_path_ids = $this->struc->getPathIds();
				$this->_path = $this->struc->getPath();*/
			} else {
				//header 404
				die( 'page does not exist' );
			}
			//return $struc;
	}	
	
	function showSite()
	{

		
		ob_start();
		
		if(defined('CMS_COMPRESS') && CMS_COMPRESS)ob_start('ob_gzhandler');
		
		$this->showSitenomal();
		
		if(defined('CMS_COMPRESS') && CMS_COMPRESS)ob_end_flush();  // The ob_gzhandler one
		

		
		header('Last-Modified: '.gmdate('D, d M Y H:i:s', $this->lastmodified).' GMT'."\r\n");
		header('Expires: '.gmdate('D, d M Y H:i:s', (time()+600)).' GMT'."\r\n");
		header('Cache-Control: max-age=600'."\r\n");
		header('ETag: '.md5($this->lastmodified.ob_get_length())."\r\n");
		header('Content-Length: '.ob_get_length()."\r\n");
		header('Accept-Ranges: bytes'."\r\n");
		/*
		gebruik $_SERVER['HTTP_HOST'] en kijk of deze met www begint
		zo niet; $URI = http://www.{domain}
		else $URI = '';
		
		 $URI .= '/';
		
		 Als niet op HOME $URI .= {path}.index.htm
		header('Content-Location: $URI'."\r\n");
		*/
		ob_end_flush();  // The main one
	
				
	}
	
	function acl()
	{
			if(defined('CMS_ACL') && !CMS_ACL)$this->_acl=null;
			else 
			{			
			//require_once 'ZendFramework-1.5.1/library/Zend/Acl.php';
			//require_once 'ZendFramework-1.5.1/library/Zend/Acl/Role.php';
			//require_once 'ZendFramework-1.5.1/library/Zend/Acl/Resource.php';
			require_once 'Zend/Acl.php';
			require_once 'Zend/Acl/Role.php';
			require_once 'Zend/Acl/Resource.php';
			
			require_once 'acl.php';
			
			$this->_acl = new MyACL( $this->_db );
			}
	}	
	
	
	function showSitenomal()
	{
		
		
		if( !$this->_db ) {
			//website unavailable: DB connection failed
			die('no db connection!');
		} elseif( ( intval(CMS_STARTSHOW) && intval(CMS_STARTSHOW) >= time() ) || ( intval(CMS_STOPSHOW) && intval(CMS_STOPSHOW) < time() ) ) {
			//website unavailable ie. expired or not launched yet
			die('website expired, or scheduled');
		} elseif( CMS_STATUS <> 'on' ) {
			die('status is not on! (status could be off or something invalid)');
		} else {
			

			$struc=$this->site_user_info();
			
            $this->acl();
			
			
			$this->glue=cmsglue::getModules();
			cmsmodules::loadModules($this->glue);

			
            

			
			

			if(defined('CMS_AUTOMT'))
			{

			require_once 'base/metadata.php';
			$metadata = new metadata();	
			$main = $this->showPosition('main');
			
			$mainm = str_replace('><','> <',$main);
			$mainm = preg_replace('/(<h[0-9]>)([^<]+)(<\/h[0-9]>)/',"$1$2.$3",$mainm);
			$mainm=preg_replace('/(<a [^>]+>)([^<]+)(<\/a>)/','$2',$mainm);
            /* niet voor geneste lijsten */
            $mainm=preg_replace('/(<\/?[u|o]l>)/','',$mainm);
			$mainm=preg_replace('/(<li>)([^<]+)(<\/li>)/',' $2, ',$mainm);
			$mainm=preg_replace('/(<\/?li>)/',' ',$mainm);
			$mainm = preg_replace('/(<t[d|h]>)([^<]+)(<\/t[d|h]>)/',"$1 $2. $3",$mainm);
			$mainm = preg_replace('/([\[])([0-9]+)(;)([0-9]+)(;)([^\]]+)([\]])/',"\\6",$mainm);
			$this->struc->keywords = $metadata->keywords($mainm);
			$this->struc->description = $metadata->description($mainm);
			if(defined('CMS_FIXAMPERSAND') && CMS_FIXAMPERSAND)
			{
			echo $metadata->my_html_entity_encode(
				 $metadata->my_html_entity_decode(
				 		 $this->showHeader(),1
                        						),1
                        					);	
			}
			else 
			{
				echo $this->showHeader();
			}	
            if(defined('CMS_FIXALIGN') && CMS_FIXALIGN)
			{
				$main = preg_replace('/ align="([^"]+)"/s',' style="float:'."\\1".'"',$main);
			}	
			
			
			
			if(defined('CMS_FIXAMPERSAND') && CMS_FIXAMPERSAND)
			{
			$main = 
			$metadata->my_html_entity_encode(
			$metadata->my_html_entity_decode(
			$this->internlinks($this->showBody($main)),1
                        						),1
                        					);	
			}
			else 
			{
				$main = $this->internlinks($this->showBody($main));
			}	
			$main = str_replace('<ul></ul>','',$main);
			echo $main;
			echo $this->showFooter();
			}
			else 
			{	
			echo $this->showHeader();
			echo $this->showBody();
			echo $this->showFooter();
			}
			$this->_db->close();
			        if( 1==1 && function_exists('memory_get_usage')) 
			        {
            $resources = getrusage();
            $execution_usertime     = sprintf( "%d.%06d", $resources["ru_utime.tv_sec"], $resources["ru_utime.tv_usec"] ) - CMS_EXECUTION_USERTIME;
            $execution_systemtime   = sprintf( "%d.%06d", $resources["ru_stime.tv_sec"], $resources["ru_stime.tv_usec"] ) - CMS_EXECUTION_SYSTEMTIME;
            echo "<!-- CPU usage user program: \t$execution_usertime sec -->\n";
            echo "<!-- CPU usage OS for user program: $execution_systemtime sec -->\n";
            echo "<!-- Total cpu usage: \t\t".($execution_systemtime+$execution_usertime)." sec (user + OS)-->\n";
            echo "<!-- Memory usage totaal: \t\t".number_format( memory_get_usage(), 0, '.', ',' )." bytes -->\n";
            echo "<!-- Memory usage cms: \t\t".number_format( memory_get_usage()-PHPUSAGE, 0, '.', ',' )." bytes -->\n";
            echo "<!-- PHP version: \t\t".phpversion()." -->\n";
            echo "<!-- Apache version: \t\t".@apache_get_version()." -->\n";
            echo "<!-- Database version: \t\t".$this->_db->version()." -->\n";
          }
        
			
			return TRUE;
		}
	}
	function maaklink($pid,$id,$language,$linktekst)
	{
		/*if(!isset($this->struc->osmenu))
		{
			$this->struc = new cmsstructure($this->_db);
			$this->showMenu();
		}
		
		/* 
		
		inladen derde keer!! 
		
		waarom niet gebruiken $this->struc->osmenu->sm ???
		
		*/
		
		$sm=unserialize(file_get_contents($_SERVER['DOCUMENT_ROOT'].'/'.str_replace('/','',CMS_BASE_URL).'/cache/'.$language.'_structure.php'));	
		
		if(!isset($sm['p'.$pid]['i'.$id]))
		{
			return $linktekst;
		}	
		else 
		{
		return '<a href="'.CMS_BASE_URL.$language.'/'.$sm['p'.$pid]['i'.$id]['data']['long_url'].'">'.$linktekst.'</a>';
		}

	}	
	function internlinks($content)
	{
		/* format [pid;id;language;linktekst] */
		return preg_replace('/([\[])([0-9]+)(;)([0-9]+)(;)([a-z]{2})(;)([^\]]+)([\]])/e',"\$this->maaklink('\\2','\\4','\\6','\\8')",$content);
	}	
	
	function getUrl()
	{
		$uri = isset( $_GET['navid'] ) ? $_GET['navid'] : '';
	
                if( ereg( "([a-z]{2})((/[a-zA-Z][a-zA-Z0-9\-_]*)*)(/([0-9]+))*(/[a-zA-Z0-9\-_./]*)?$", strtolower( $uri ), $urlmatch ) ) {

                		$language =   $urlmatch[1];
  
                        define( 'CMS_CURRENT_URL', $urlmatch[2] );
                        define( 'CMS_CURRENT_ID', strval ($urlmatch[5]) );
                } elseif( ereg( "([a-z]{2})((/[a-zA-Z0-9-]+)*)/?$", strtolower( $uri ), $urlmatch ) ) {
			$language =   $urlmatch[1];
                        define( 'CMS_CURRENT_URL', $urlmatch[2] );
                        define( 'CMS_CURRENT_ID', 0 );
		} else {
			define( 'CMS_CURRENT_URL', '' );
			define( 'CMS_CURRENT_ID', 0 );
		}
	
		if( isset( $language ) ) {
			if( strpos( CMS_LANGUAGES, $language ) === FALSE ) {
				define( 'CMS_CURRENT_LANGUAGE',  CMS_LANGUAGES_DEFAULT );
			} else {
				define( 'CMS_CURRENT_LANGUAGE', $language );
			}
			if( defined('CMS_LANGUAGES_EXTRA') && strpos( CMS_LANGUAGES_EXTRA, $language ) !== FALSE)
		{
			define( 'CMS_OVERRULED_LANGUAGE',  $language);
		}	
		else 
		{
			define( 'CMS_OVERRULED_LANGUAGE',  0);
		}	
		} 
		
		else {
			define( 'CMS_CURRENT_LANGUAGE', CMS_LANGUAGES_DEFAULT );
			define( 'CMS_OVERRULED_LANGUAGE',  0);
			}


			
		setlocale( LC_ALL, CMS_CURRENT_LANGUAGE );
	}			
	
	//move to glue or structure?
	function showPosition( $position )
	{

		if ( CMS_USER_HASRIGHTS ) 
		{
			$glue = new cmsglue( $this->_db, $this->_acl );
			return $glue->getContent( $position );
		} else {
			return cmstemplates::show( 'cmsstructure_restricted', 'cmsstructure', '' );
		}
			
	}
	

	
	//pid = parent id, starts with items which have pid as parent (0=root)
	//levels = number of levels deep (0= unlimited)
	//limit = max number of items (ie. space is limited) (0 = unlimited)
	//selected = id of current page
	//style = 'fold' or 'expand' (fold=hide submenu's, but show them when selected, expand=always show all submenu's)
	function showMenu($fold=1, $id = -1, $pid = -1,$pretemp='',$max=0)
	{
		return $this->struc->showMenuLevel($fold,$id,$pid,$pretemp,$max);
	}
	
	function showBreadcrumbs()
	{
		return $this->struc->showBreadcrumbs();
	}
	
	function showChecklink()
	{
		require_once('cmschecklink/cmschecklink.php');
		$cl = new cmschecklink($this->_db);
		return $cl->showlink(CMS_CURRENT_URL);
		
	}
	
	function showHtmlvalidation()
	{
		require_once('cmshtmlvalidation/cmshtmlvalidation.php');
		$hv = new cmshtmlvalidation($this->_db);
		return $hv->showlink(CMS_CURRENT_URL);
		
	}
	
	function showWDGHtmlvalidation()
	{
		require_once('cmswdghtmlvalidation/cmswdghtmlvalidation.php');
		$hvwdg = new cmswdghtmlvalidation($this->_db);
		return $hvwdg->showlink(CMS_CURRENT_URL);
		
	}

	function showHeader(  )
	{
        $vars['title'] = defined('CMS_DEFAULT_TITLE') ? (CMS_DEFAULT_TITLE.' :: ') : ''; 
        
        if(defined('SUBSITEPID') && $this->struc->pid>SUBSITEPID && !empty($this->struc->osmenu->sm['p'.SUBSITEPID]['i'.$this->struc->pid]['data']['title']))
        {
        	
        $vars['title'] .=  $this->struc->osmenu->sm['p'.SUBSITEPID]['i'.$this->struc->pid]['data']['title'] . ' :: ';
        }
              
        $vars['title'] .= !empty($this->struc->_titles[CMS_CURRENT_LANGUAGE])?$this->struc->_titles[CMS_CURRENT_LANGUAGE]:(isset($this->struc->_titles[CMS_LANGUAGES_DEFAULT])?$this->struc->_titles[CMS_LANGUAGES_DEFAULT]:'');		
		
                
		if( $this->struc->description ) {
			$vars['description'] = $this->struc->description;
		} else {
			$vars['description'] = $vars['title'];
		}
		if( $this->struc->keywords ) {
			$vars['keywords'] = $this->struc->keywords;
		} else {
			$vars['keywords'] = str_replace(' ',',',$vars['title']);
		}                                       
		$vars['extraheaders'] = '';
		$vars['stylesheet'] = '';
		$vars['javascript'] = '';
		//var_dump($this->glue);
		$stylesheets = cmstemplates::getStylesheet($this->glue,$this->struc->css);

		$templ = cmstemplates::loadfile( 'stylesheets', 'cmstemplates' );
		foreach ($stylesheets as $stylesheet) {

			$vars['stylesheet'] .= cmstemplates::parse( $templ,array('stylesheet'=>$stylesheet));
		}
		
		define('CMS_MODULE_STYLSHEETS',$vars['stylesheet']);
		
		$javascripts = cmstemplates::getJavascripts($this->glue,$this->struc->css);

		if(count($javascripts)>0)
		{
		$templ = cmstemplates::loadfile( 'javascripts', 'cmstemplates' );
		foreach ($javascripts as $javascript) {							
			$vars['javascript'] .= cmstemplates::parse( $templ,array('javascript'=>$javascript));
		}
		
		define('CMS_MODULE_JAVASCRIPTS',$vars['javascript']);
		}

		if($this->struc->header_template && strstr($this->struc->header_template,'_php'))
		{
		/* 19 01 2008 
		php en vars
		*/	 

		return cmstemplates::parse($this->get_include_contents($_SERVER['DOCUMENT_ROOT'].CMS_BASE_URL.'templates/'.$this->struc->header_template.'.tpl'),$vars);
		
		}
		/*elseif( file_exists( 'templates/'.CMS_TEMPLATES_DEFAULT_HEADER_PHP.'.tpl' ) ) {
		require_once( 'templates/'.CMS_TEMPLATES_DEFAULT_HEADER_PHP.'.tpl' );
		} */
		else 
		{
		$vars['favicon'] = cmstemplates::getFavicon();
		$vars['doctype'] = cmstemplates::getDoctype();
		return cmstemplates::show(($this->struc->header_template)?$this->struc->header_template:CMS_TEMPLATES_DEFAULT_HEADER, '', $vars );
		}
	}
	
	function get_include_contents($filename,$main='') 
	{

   if (is_file($filename)) {

       ob_start();
       include $filename; 
       $contents = ob_get_contents();
       ob_end_clean();
       return $contents;
   }
    return false;
	}

	function showBody($main='')
	{	

		if($this->struc->body_template && strstr($this->struc->body_template,'_php')) 
		{
			
			return $this->get_include_contents($_SERVER['DOCUMENT_ROOT'].CMS_BASE_URL.'templates/'.$this->struc->body_template.'.tpl',$main);

			//return require_once( 'templates/'.$this->struc->body_template.'.tpl');
		}
		elseif( file_exists( 'templates/'.CMS_TEMPLATES_DEFAULT_BODY_PHP.'.tpl' ))  {
			
			return $this->get_include_contents('templates/'.CMS_TEMPLATES_DEFAULT_BODY_PHP.'.tpl',$main);
			//require_once( 'templates/'.CMS_TEMPLATES_DEFAULT_BODY_PHP.'.tpl' );
		} else {

			$vars['menu'] = $this->showMenu( 1 );
			$vars['breadcrumbs'] = $this->showBreadcrumbs();
			$vars['content'] = $this->showPosition( 'main' );
			//$vars['checklink'] = $this->showChecklink();
			//$vars['htmlvalidation'] = $this->showHtmlvalidation();
			//$vars['htmlwdgvalidation'] = $this->showWDGHtmlvalidation();
			foreach($this->glue as $array)
			{
				if($array[1]!='main')
				{
					$vars[$array[1]] = $this->showPosition( $array[1] );
				}	
			}

			return cmstemplates::show(($this->struc->body_template)?$this->struc->body_template:CMS_TEMPLATES_DEFAULT_BODY, '', $vars );
		}
	}

	function showFooter()
	{
		if($this->struc->footer_template && strstr($this->struc->footer_template,'_php')) require_once($_SERVER['DOCUMENT_ROOT'].CMS_BASE_URL.'templates/'.$this->struc->footer_template.'.tpl');

		elseif( file_exists( 'templates/'.CMS_TEMPLATES_DEFAULT_FOOTER_PHP.'.tpl' ) ) {
		require_once( 'templates/'.CMS_TEMPLATES_DEFAULT_FOOTER_PHP.'.tpl' );
		} 
		else return cmstemplates::show(($this->struc->footer_template)?$this->struc->footer_template:CMS_TEMPLATES_DEFAULT_FOOTER , 'cmstemplates', '' );
	}

	function showAdmin()
	{
		
		define('CMS_OVERRULED_LANGUAGE',0);
		require_once 'cmstemplates/cmstemplatesadmin.php';
		$vars = array();
			
		
		if( isset( $_GET['module'] ) ) {
			$_GET['module'] = strtolower( $_GET['module'] );
		}
		if( isset( $_GET['action'] ) ) {
			$_GET['action'] = strtolower( $_GET['action'] );
		}
		
		if( $this->_db )
		{
			
			cmsmodules::check_tables( $this->_db );
			

			$this->_currentuser = new cmsusers( $this->_db );
			if( isset( $_GET['action'] ) && $_GET['action'] == 'logout' )
			{
				$this->_currentuser->logout();
			} 
			else 
			{
				$this->_currentuser->login();
			}
	        $this->acl();
			define( 'CMS_CURRENT_LANGUAGE', $this->_currentuser->language );
		

			
	    /* set docs_language */
		if(isset($_GET['id']) && !is_numeric( $_GET['id'] ))
		{
			$vars['item_language'] = substr( $_GET['id'], 0, 2 );
			
		}
		
		if(empty($vars['item_language'])) $vars['item_language'] = $this->_currentuser->language;
					
			
			
			
			if( intval( CMS_CURRENT_USER_ID ) && $this->_currentuser->hasRights( 'reviewer' ) ) 
			{

			/* load module */
			if(!isset($_GET['module'])) $_GET['module']='';
			$call=$_GET['module'];
			$pieces=explode('_',$_GET['module']);
			$path='';
			
			
			if(count($pieces)>1)
			{
				for($i=0; $i<count($pieces)-1; $i++)
				{
					$path.=$pieces[$i].'/';
				}	
				
				//$_GET['module'] = $pieces[(count($pieces)-2)];
				$_GET['module']=$pieces[$i];

			}	
			
			$mods = cmsmodules::loadArray();
			
			$call4rights=str_replace('_admin','',$call);
			if(strstr($call4rights,'_'))
			{
				/*{hoofdmodule}_{submodule}
				alleen toegang tot de hoofdmodule wordt getest
				*/
				$call4rights = substr($call4rights,0,(strpos($call4rights,'_')));
			}	
            echo 
            $aclcheck = false;
			if(!is_null($this->_acl) 
			&& $this->_acl->has($call4rights) 
			&& $this->_acl->isAllowed( CMS_CURRENT_USER_ID, $call4rights , 'admin' )
			)
			{
				$aclcheck = true;	
			}  
			if
			(
			(!isset($mods[$call4rights][2]) && $_GET['module']!='cms')||
			(
			(isset($_GET['module']) && $_GET['module']!='cms')
			&& !$aclcheck
			&& !cmsusers::hasRights( $mods[$call4rights][2], CMS_CURRENT_USER_TYPE ))
			)
			{

				$vars['menu'] = '';
				$vars['main'] = cmstemplates::show('admin_login', 'cmsusers', '' );
			}
				
			else 
			{		
			

	 		if(file_exists(CMS_LIB_PATH.$path.$_GET['module'].'/'.$_GET['module'].'_admin.php') || file_exists(CMS_CLIENT_PATH.'/modules/'.$path.$_GET['module'].'/'.$_GET['module'].'_admin.php'))$call.='_admin';
		

			$_GET['module']=$call;

	
			$modules[$call] = array('','1','none','1');
			
	
			
			
			
			
			cmsmodules::loadModules($modules,true);
				
		
			
				
				if( empty( $_GET['module'] ) ) {
					$_GET['module'] = 'cms';
				}
				if( !isset( $_GET['action'] ) ) {
					$_GET['action'] = 'adminsummary';
				}
				if( !isset( $_GET['id']  ) ) {
					$_GET['id'] = 0;
				}
				
				setlocale( LC_ALL, CMS_CURRENT_LANGUAGE );
				CMSLanguages::loadTranslation( CMS_CURRENT_LANGUAGE );
				CMSLanguages::loadAdminTranslation( CMS_CURRENT_LANGUAGE );
				$menu = new cmsmodules( $this->_db );
				if( $_GET['module'] == 'cms' ) {

					$content = $this;
				} else 
				{

					
					//$this->_db = new EstrateDB($this->_db);
					
					if($_GET['module']=='cmsstructure_cmsmetadata')
					{
					$object = & new cmsstructure( $this->_db );
					$content = & new cmsmetadata($object);
					}
					elseif(!preg_match('/_admin$/',$_GET['module']))
					{
					$module =preg_replace('/(([a-z]+_)+)([a-z]+$)/','\\3',$_GET['module']);
					$content = new $module( $this->_db,$this->_acl);
					}
					else 
					{
					$module = $_GET['module'];
					$pieces=explode('_',$_GET['module']);
					$object = & new $pieces[count($pieces)-2]( $this->_db,$this->_acl );
					$module= $pieces[count($pieces)-2].'_'.$pieces[count($pieces)-1];
					$content = & new $module($object);
					}
					
				}

				$vars['menu'] = $menu->showAdminMenu($this->_acl);
				$vars['main'] = $content->$_GET['action']( $_GET['id'] );
				}
			} else {
				$vars['menu'] = '';
				$vars['main'] = cmstemplates::show('admin_login', 'cmsusers', '' );
			}
		} else {
			$vars['menu'] = '';
			$vars['main'] = cmstemplates::show('admin_login', 'cmsusers', '' );
		}
		echo cmstemplates::show( 'admin', '', $vars );
		$this->_db->close();
		return TRUE;
	}

	function adminSummary( $id = 0 )
	{
		myautoload('oscmsadminsummary');
		$oscmsadminsummary = new oscmsadminsummary($this->_db,$this->_acl);
		return $oscmsadminsummary->show();
		//return cmstemplates::show( 'cms_summary', 'cmstemplates', '' );
	}

	function adminConfig( $id )
	{
		return cmstemplates::show( 'config', 'cmstemplates', '' );
	}

	function changeLanguage( $lang )
	{
		return CMS_BASE_URL.$lang.substr( $this->_url, 3 ).( CMS_CURRENT_ID ? CMS_CURRENT_ID.'/' : '' );
	}
}
?>