<?php
/*

EstrateCMS

EstrateCMS is a Content Management System for professional websites.

Copyright (C) 2004, 2005, Estrate, Rudolph Froger, The Netherlands
Website:        http://www.estrate.nl
Postal address: Estrate
                Oostsingel 57B
                2612HD Delft
                The Netherlands

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

A copy of the license should be in the file named LICENSE.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

myautoload('cmsimages_cmsimagescategories');


define( 'MODULE_CMSIMAGES', TRUE );

class cmsimages extends EstrateDB
{
	var	$id;
	var	$filename;
	var	$categoryid;
	var	$update_time;
	var	$insert_time;
	var	$_titles_tablename;
	var	$_categories_tablename;
	var $_parent;
	var $_class;

	function __construct( &$db )
	{
		EstrateDB::EstrateDB( $db );
		

		$this->_titles_tablename = $this->_tablename.'titles';
		$this->_categories_tablename = $this->_tablename.'categories';
		require_once( CMS_CURRENT_LANGUAGE.'.php' );

		if( !defined( 'CMS_IMAGES_ORIGINAL_DIR' ) ) {
			define( 'CMS_IMAGES_ORIGINAL_DIR', 'userimg/original/' );
		}
		if( !defined( 'CMS_IMAGES_SCALED_DIR' ) ) {
			define( 'CMS_IMAGES_SCALED_DIR', 'userimg/' );
		}
		if( !defined( 'CMS_IMAGES_THUMBS_DIR' ) ) {
			define( 'CMS_IMAGES_THUMBS_DIR', 'userimg/thumbs/' );
		}
		if( !defined( 'CMS_IMAGES_SCALE_TYPE' ) ) {
			define( 'CMS_IMAGES_SCALE_TYPE', 'fit' );
		}
		if( !defined( 'CMS_IMAGES_SCALE_BLOWUP' ) ) {
			define( 'CMS_IMAGES_SCALE_BLOWUP', 'no' );
		}
		if( !defined( 'CMS_IMAGES_SCALED_SIZE' ) ) {
			define( 'CMS_IMAGES_SCALED_SIZE', '640x640' );
		}
		if( !defined( 'CMS_IMAGES_THUMBS_SIZE' ) ) {
			define( 'CMS_IMAGES_THUMBS_SIZE', '120x120' );
		}
		if( !defined( 'CMS_IMAGES_CATEGORY_TABLE' ) ) {
			//table size in [cols]x[rows]
			define( 'CMS_IMAGES_CATEGORY_TABLE', '7x3' );
		}
		
		$this->_parent=get_parent_class($this);
		$this->_class= get_class($this);
		$this->_class=str_replace('admin','',$this->_class);
		if(strstr($this->_class,'_'))list($this->_class,$rotzooi)=explode('_',$this->_class);
	}

	
	function show( $id ) {
		if( $id ) {
			$id = intval( $id );
		} elseif( CMS_CURRENT_ID ) {
			$id = CMS_CURRENT_ID;
		} else {
			return FALSE;
		}
	}
}
?>