CREATE TABLE `cmsimages2` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `filename` varchar(80) NOT NULL default '',
  `categoryid` int(10) unsigned NOT NULL default '0',
  `update_time` int(10) unsigned NOT NULL default '0',
  `insert_time` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `categoryid` (`categoryid`),
  KEY `update_time` (`update_time`)
);

CREATE TABLE `cmsimages2cats` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `pid` int(10) unsigned NOT NULL default '0',
  `priority` int(10) unsigned NOT NULL default '50',
  `status` enum('off','on') NOT NULL default 'on',
  PRIMARY KEY  (`id`),
  KEY `freqselect` (`status`,`pid`)
);

CREATE TABLE `cmsimages2catstitles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `categoryid` int(10) unsigned NOT NULL default '0',
  `language` char(2) NOT NULL default 'nl',
  `title` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `default_select` (`categoryid`,`language`)
);

CREATE TABLE `cmsimages2titles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `imageid` int(10) unsigned NOT NULL default '0',
  `language` char(2) NOT NULL default 'nl',
  `title` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `default_select` (`imageid`,`language`)
);
