CREATE TABLE `cmsstructure` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `url` varchar(255) NOT NULL default '',
  `long_url` varchar(255) NOT NULL default '',
  `external_url` varchar(255) NOT NULL default '',
  `pid` int(10) unsigned NOT NULL default '0',
  `menu` enum('show','hide') NOT NULL default 'show',
  `status` enum('off','on') NOT NULL default 'on',
  `requiredrights` enum('none','user','member','reviewer','editor','admin') NOT NULL default 'none',
  `description` tinytext NOT NULL,
  `keywords` tinytext NOT NULL,
  `body_template` varchar(255) default NULL,
  `header_template` varchar(255) default NULL,
  `footer_template` varchar(255) default NULL,
  `css` varchar(255) default NULL,
  `priority` int(10) unsigned NOT NULL default '0',
  `update_time` int(11) NOT NULL default '0',
  `insert_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `load_by_url` (`status`,`long_url`),
  KEY `get_menu` (`status`,`menu`,`pid`),
  KEY `priority` (`priority`)
);

CREATE TABLE `cmsstructuretitles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `language` char(2) NOT NULL default '',
  `sid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `default_select` (`language`,`sid`)
);
