<?
myautoload('cmsarticles_admin');
myautoload('cmsstructure_cmsstructureacticles');
myautoload('cmsstructure_admin');
class cmsstructureacticles_admin extends cmsarticles_admin
{

	
	var $object;
	
	function cmsstructureacticles_admin (&$object)
	{
		$this->object=$object;
		
	}

	function structureadminList($sid)
	{
		$sql = 'SELECT id, title, language, status, startshow, stopshow,`sid` FROM cmsarticles WHERE `sid`='.$sid.' AND NOT pid ORDER BY priority';
		return cmstemplatesadmin::adminSingleList( $this->object->_db, 'cmsstructure_cmsstructureacticles', $this->object->_tablename, $sql,0,0,20,'',1,$sid);
		//return $this->structureadminSingleList('cmsstructure_cmsstructureacticles',$sql,$sid);
	}
	
	function structureadminSingleList($module, $sql, $sid)
	{
		/*
		Simple-style admin-list (ie. contactforms, mailforms, weblog)
		*/
		$tpl_main 	= cmstemplates::loadfile( 'adminhlist', 'cmsstructure' );
		$tpl_legenda 	= cmstemplates::loadfile( 'adminlist_leg', 'cmstemplates' );
		$tpl_row 	= cmstemplates::loadfile( 'adminhlist_rowupdown', 'cmsstructure' );
		$tpl_updown_links = cmstemplates::loadfile( 'cmsarticles_admin_updownlink', 'cmsstructure' );
		$rs = $this->object->_db->Execute( $sql );
		$row = '';
		$i=1;
		$vars['module'] = $module;

		$vars['sid'] = $sid;
		
		if($rs)while($rec = $rs->FetchRow() ) 
		{
			$rec=array_merge($vars,$rec);
			if($i==1)$rec['uplink']='&nbsp;';
			else $rec['uplink']=cmstemplates::parse( $tpl_updown_links, array_merge($rec,array('what'=>'up')) );
			
			if($i==$rs->RecordCount())$rec['downlink']='&nbsp;';
			else $rec['downlink']=cmstemplates::parse( $tpl_updown_links, array_merge($rec,array('what'=>'down')) );
						
			
			$rec = array_merge( $rec, cmstemplatesadmin::adminList_status( $rec ) );
			$row .= cmstemplates::parse( $tpl_row, $rec);
		
			$i++;
		}
		$vars['rows'] = $row;
		
		$vars['explain'] = constant( strtoupper( 'ADM_CMSSTRUCTURE_EXPLAIN' ) );
		$vars['legenda'] = cmstemplates::parse( $tpl_legenda, '' );
		return cmstemplates::parse( $tpl_main, $vars );
	}
	
	function adminEdit( $id )
	{
			$vars=$this->getadmineditvars($id);	
			$templ_link=cmstemplates::loadfile('a','cmstemplates/a');
			$input_template = cmstemplates::loadfile( 'form/input', 'cmstemplates' );	
			$vars['recalculate'] = cmstemplates::parse($input_template,array('type'=>'checkbox','name'=>'recalculate','value'=>'1','checked'=>'checked'));
			$vars['recalculate'] .= 'Recalculate meta data';
		    unset($input_template);
			$vars['class']='cmsstructureacticles';
			$vars['breadcrumbs']=$this->breadcrumbs(empty($id)?$_GET['sid']:$this->object->sid,true);
			return cmstemplates::show( 'cmsarticlesstructure_edit', 'cmsstructure', $vars );
			
	}
	
	function breadcrumbs($pid,$item=false)
	{
		/* built breadcrumbs */

		    $sql = 'SELECT `title`'
        	. ' FROM `cmsstructure` LEFT JOIN cmsstructuretitles ON `cmsstructure`.`id`=`cmsstructuretitles`.`sid`  WHERE `cmsstructure`.`id`='.$pid.' AND `language`=\''.$this->object->language.'\'';

        	$rs = $this->object->_db->Execute( $sql );
            $archive=$rs->Fields('title');
		
        $templa = cmstemplates::loadfile( 'a/a', 'cmstemplates' );
		$breadcrumbs  = cmstemplates::parse($templa,array('url'=>'admin.php?module=cmsstructure&action=adminList','text'=>'Structuur','end'=>' &gt; '));
        if($item)
        {
		$breadcrumbs .= cmstemplates::parse($templa,array('url'=>'admin.php?module=cmsstructure&action=adminedit&id='.$pid,'text'=>$archive,'end'=>' &gt; '));
		$breadcrumbs .= empty($this->object->title)?ADM_CMSARTICLES_NEWITEM:$this->object->title; 
        }
        else  $breadcrumbs .= $archive;
		return  $breadcrumbs;
	}	
	
	function sidlist()
	{
		$input_template = cmstemplates::loadfile( 'form/input', 'cmstemplates' );	
		return cmstemplates::parse($input_template,array('type'=>'hidden','name'=>'sid','value'=>empty($this->object->sid)?$_GET['sid']:$this->object->sid));
		unset($input_template);
	}	
	
	function adminSave( $id )
	{
		

		$this->object->load( $id );
		$old_sid = $this->object->sid;
		$old_content_type = $this->object->content_type;
		$this->object->bind( $_POST );
		
		if(empty($id) || $old_sid!=$this->object->sid)$this->updatesids($old_sid);
			
		$this->object->save();
		$obj = new cmsstructure($this->object->_db);
		
		if($old_sid && $old_sid!=$this->object->sid)
		{
		$obj->load($old_sid);
        $obj->update_time=time();
		$obj->save();
		}	
		
		$obj->load($this->object->sid);
        $obj->update_time=time();
		$obj->save();
		
		if(isset($_POST['recalculate']))
		{
			myautoload('cmsstructure_cmsmetadata');
			
			$meta = new cmsstructure_cmsmetadata($obj);
			$meta->recalculate($this->object->sid,$this->object->id);
		}
		return $this->adminEdit( $this->object->id );
	
	}
	
	function on( $id = 0 )
	{
		if( $id ) {
			$this->object->on( $id );
			$obj=new cmsstructure($this->object->_db);
			$structure=new cmsstructure_admin($obj);
			return $structure->adminEdit( $this->object->sid );
		}
	}
	
	

	function off( $id = 0 )
	{
		if( $id ) {
			$this->object->off( $id );
			$obj=new cmsstructure($this->object->_db);
			$structure=new cmsstructure_admin($obj);
			return $structure->adminEdit($this->object->sid );
		}
	}
		function down( $id = 0 )
	{
		if( $id ) {
			$this->object->down( $id );
			$obj=new cmsstructure($this->object->_db);
			$structure=new cmsstructure_admin($obj);
			return $structure->adminEdit( $_GET['sid'] );
		}
	}

	function up( $id = 0 )
	{
		if( $id ) {
			$this->object->up( $id );
			$obj=new cmsstructure($this->object->_db);
			$structure=new cmsstructure_admin($obj);
			return $structure->adminEdit( $_GET['sid'] );
		}
	}
	
	function adminDelete( $id )
	{
		$this->object->load( $id );
		$this->object->delete();
		$obj=new cmsstructure($this->object->_db);
		$structure=new cmsstructure_admin($obj);
		return $structure->adminEdit( $_GET['sid'] );
	}

	function adminConfirmDelete( $id )
	{
		$this->object->load( $id );
		$vars = array( 	'module' => 'cmsstructure_cmsstructureacticles',

				'id' => $this->object->id,
				'sid' => $this->object->sid,
				'title' => $this->object->title );
				
		return cmstemplates::show( 'delete', 'cmsstructure', $vars );
	}
}
?>	