<?php
defined( 'OSC_SECURE' ) or die( 'Restricted access' );
//MySQL version of classes 'db' and 'db_result'

class db
{
    var $_connection;       //db connection
    var $_sql;              //last sql query
    var $_database;         //name of database

    function db( &$cfg )
    {
        if( $cfg['db_type'] == 'mysql' ) {
            return $this->connect( $cfg );
        } else {
            $this->fout( 'Wrong database layer loaded or wrong database type.' );
        } 
    }

    function connect( &$cfg )
    {
    	if( isset( $cfg['db_host'] ) && isset( $cfg['db_username'] ) && isset( $cfg['db_password'] ) ) {
            $this->_connection = mysql_connect( $cfg['db_host'], $cfg['db_username'], $cfg['db_password'] );
            if( $this->_connection ) {
                if( mysql_select_db( $cfg['db_database'] ) ) {
                    $this->_database = $cfg['db_database'];
                    return TRUE;
                } else {
                    $this->fout( 'Could not select the database. Make sure you provided the right database.' );
                } 
            } else {
                $this->fout( 'Database connection failed. Did you provide the right hostname, username and password?' );
            } 
        } else {
            $this->fout( 'Database configuration data is NOT complete.' );
        } 
    }

    function fout($fout)
    {
    	error_log('MYSQL '.$_SERVER['SERVER_NAME'].': ' .$fout.' ('.mysql_error().')',0); 
    	
    	if( CMS_DEBUG ) die($fout);
    	return false;
    }	
    
    function execute( $sql )
    {
        if( $sql ) {
        	
            $resource = mysql_query( $sql, $this->_connection ) or die( mysql_error() . 'query:'.$sql);
            if( CMS_DEBUG == 2 ) {
                 echo "<!-- $sql -->\n";
            }
            if( $resource ) {
                $result = new db_result( $resource );
                return $result;
            } else 
            {
                      	return FALSE;
            }
        } else {
            return FALSE;
        }
    }

    function select( $sql )
    {
        return $this->execute( $sql );
    }

    function selectLimit( $sql, $nrrows = -1, $offset = -1 )
    {
        $offsetStr =($offset>=0) ? "$offset," : '';
        // jason judge, see http://phplens.com/lens/lensforum/msgs.php?id=9220
        if ($nrrows < 0) $nrrows = '18446744073709551615';
        return $this->execute($sql." LIMIT $offsetStr$nrrows");
    }
    
    function close()
    {
        return mysql_close( $this->_connection );
    }

    function affected_rows()
    {
        return @mysql_affected_rows();
    }

    function insert_id()
    {
        return @mysql_insert_id();
    }

    function metaTables()
    {
        $rs = $this->execute( 'SHOW TABLES FROM `'.$this->_database.'`' );
        if( $rs ) {
            $result = array();
            while( $record = $rs->fetchRow() ) {
                $result[] = array_pop( $record );
            }
            return $result;
        } else {
            return FALSE;
        }
    }

    function error()
    {
        return mysql_error();
    }

    function version()
    {
        //return 'MySQL '.mysql_get_server_info();
    }

    function quote( $value )
    {
    	if ( is_numeric( $value ) ) {
            return $value;
        } else {
        return '\'' . mysql_real_escape_string( encodehtml($value) ) . '\'';
	    return '\'' .  str_replace('\'','\\\'',encodehtml($value) ) . '\'';
        }
    }
    
    function ErrorMsg()
    {
    	return mysql_error();
    }	
}

class db_result
{
    var $resource;

    function db_result( &$resource )
    {
        $this->resource = $resource;
    }
    
    function fetchRow()
    {
        return mysql_fetch_assoc( $this->resource );
    }

    function getAssoc()
    {
        $result = FALSE;
        $first = TRUE;
        while( $record = mysql_fetch_assoc( $this->resource ) ) {
            if( $first ) {
                $first  = FALSE;
                $fields = array_keys( $record );
                if( count( $fields ) == 2 ) {
                    $dual = TRUE;
                } else {
                    $dual = FALSE;
                }
            }
            if( $dual ) {
                $result[ $record[$fields[0]] ] = $record[$fields[1]];
            } else {
                $fieldname = $record[$fields[0]];
                unset( $record[$fields[0]] ); 
                $result[ $fieldname ] = $record;
            }
        }
        return $result;
    }

    function getArray($result_type=MYSQL_BOTH)
    {
        $result = array();
      
        while( $row = mysql_fetch_array( $this->resource, $result_type) ) 
        {
            
           $result[]=$row;

        }
        return (empty($result)?false:$result);
    }

    function recordCount()
    {
        return $this->_num_rows = mysql_num_rows( $this->resource );
    }
    
    function fields($fieldname='',$row=0)
    {
    if(!$this->resource) 
    {
        die('Ongeldig veld '.$fieldname);
    }
    if(($n = mysql_num_rows($this->resource))<($row+1))
    {
    	die(($row+1).' Rows gevraagd '.$n.' gevonden (veld: '.$fieldname.').');
    }	
	return mysql_result($this->resource,$row,$fieldname);
    }
    
    function ErrorMsg()
    {
    	$this->fout('Query failed: ');
    }	
    
 	
}

?>