<?
/*
copyright 2001, Email Communications
http://www.emailcommunications.nl
Last change: 21-03-2003
Serialize/unserialize and store an array in a file
*/

class savedarray
{
	var $array;
	var $filename;
	
	function savedarray($file='',$read=1)
	{
		$this->array=array();
		$this->filename=$file;
		if($read)
		{
		$this->read_array();
		return $this->array;
		}
	}	
	
	function read_array($file='')
	{
	clearstatcache();
	$fp=fopen(empty($file)?$this->filename:$file,'r');
	flock($fp,1);
	if(filesize(empty($file)?$this->filename:$file)>0)$this->array=unserialize(fread($fp,filesize(empty($file)?$this->filename:$file)));
	flock($fp,3);
	fclose($fp);
	return $this->array;
	}

	function save_array($file='')
	{
	$fp=fopen(empty($file)?$this->filename:$file,'w+');
	flock($fp,2);
	fwrite($fp,serialize($this->array));
	flock($fp,3);
	fclose($fp);
	}
	
	function add($add,$save=1,$file='')
	{
		if(!empty($add) && is_array($add))
		{
			while(list($key,$value)=each($add))
			$this->array[$key]=$value;
		}
		elseif(!empty($add))$this->array[]=$add;
		if($save)$this->save_array(empty($file)?$this->filename:$file);
		return true;
	}
	
	function remove_key($key,$save=1,$file='')
	{
		unset($this->array[$key]);
		if($save)$this->save_array($file);
		return true;
	}

	function remove_value($value,$save=1,$file='')
	{
		foreach ($this->array as $key=>$valuea)
		if($valuea==$value)
		{
		unset($this->array[$key]);
		break;
		} 

	//unset($this->array[$y-1]);
	if($save)$this->save_array($file);
	return true;
	}
}
?>
