CREATE TABLE `cmsarticles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(150) NOT NULL default '',
  `content_a` text NOT NULL,
  `content_b` text NOT NULL,
  `content_type` enum('default','columns','intro') NOT NULL default 'default',
  `sid` int(10) unsigned NOT NULL default '0',
  `pid` int(10) unsigned NOT NULL default '0',
  `language` char(2) NOT NULL default 'nl',
  `priority` int(10) unsigned NOT NULL default '0',
  `status` enum('on','off') NOT NULL default 'on',
  `startshow` int(10) unsigned NOT NULL default '0',
  `stopshow` int(10) unsigned NOT NULL default '0',
  `update_time` int(11) NOT NULL default '0',
  `insert_time` int(11) NOT NULL default '0',
  `showtitle` enum('on','off') NOT NULL default 'on',
  PRIMARY KEY  (`id`),
  KEY `default_select` (`language`,`sid`,`status`),
  KEY `startshow` (`startshow`,`stopshow`)
);
