<?php
myautoload('cmsarticles');

class cmsarticles_admin
{
/**/

	var $object;

	function cmsarticles_admin (&$object)
	{
		$this->object=$object;
	}


	function adminList($page = 0)
	{
		$sql = "SELECT id, title, language, status, startshow, stopshow FROM ".$this->object->_tablename." WHERE NOT pid ORDER BY title, id";
		return cmstemplatesadmin::adminSingleList( $this->object->_db, $this->object->_tablename, $this->object->_tablename, $sql,0,$page);
	}

	function adminEdit( $id )
	{
		$vars=$this->getadmineditvars($id);
		$vars['content_b']=$GLOBALS['cms']->internlinks($vars['content_b']);
		return cmstemplatesadmin::show( 'cmsarticles_edit', $this->object->_tablename, $vars );
	}

	function getadmineditvars(&$id)
	{

		$this->getid($id);
		$vars = get_object_vars( $this->object );
		$vars['module'] = $this->object->_tablename;
		$vars['startshow'] = inputDate( 'startshow', $this->object->startshow, TRUE );
		$vars['stopshow'] = inputDate( 'stopshow', $this->object->stopshow, TRUE );
		$this->contentedit($vars);
		$vars['sid_list'] = $this->sidlist();
			
		$input_template = cmstemplatesadmin::loadfile( 'form/input', 'cmstemplates' );
		$i=array('type'=>'checkbox','name'=>'showtitle','value'=>'off');
		if($vars['showtitle']=='off')$i['checked']='checked';
		$vars['showtitle'] = cmstemplatesadmin::parse($input_template,array('type'=>'hidden','name'=>'showtitle','value'=>'on'));
		$vars['showtitle'] .= cmstemplatesadmin::parse($input_template,$i);
		$vars['showtitle'] .= ADM_CMSARTICLES_NO_TITLE;

		return $vars;
	}

	function getid(&$id)
	{
		if( $id && is_numeric( $id ) ) {
			$this->object->load( $id );
		} elseif( $id ) {
			 
			$language = substr( $id, 0, 2 );
			$pid = intval( substr( $id, 2 ) );
			if( $pid && $language ) {
				$this->object->load( $pid );
				$this->object->id = 0;
				$this->object->pid = $pid;
				$this->object->language = $language;
			}
		} else {
			$this->object->language = CMS_LANGUAGES_DEFAULT;
		}
	}

	function sidlist()
	{
		return;
		myautoload('cmsstructure_admin');
		$obj = & new cmsstructure($this->object->_db);
		$struc = new cmsstructure_admin( $obj );
		return $struc->adminSelectLongURLList( 'sid', $this->object->sid );
	}

	function contentedit(&$vars)
	{
		if( empty( $this->object->content_type ) ) {
			$this->object->content_type = CMS_ARTICLES_CONTENT_TYPE;
		}

		$c_template = cmstemplatesadmin::loadfile( 'edit_content', $this->object->_tablename );
		$mce_editable = 'true';
		if( !$this->object->content_a ) {
			$this->object->content_a = '<p><br /></p>';
		}
		if( !$this->object->content_b ) {
			$this->object->content_b = '<p><br /></p>';
		}
		if( $this->object->content_type == 'intro' ) {
			$c_vars = array( 'title' => ADM_CMSARTICLES_CONTENT_INTRO,
						'name' => 'content_a',
						'mce_editable' => $mce_editable,
						'content' => $this->object->content_a );
			$vars['content_a'] = cmstemplatesadmin::parse( $c_template, $c_vars );
			$c_vars = array( 'title' => ADM_CMSARTICLES_CONTENT_MAIN,
						'name' => 'content_b',
						'mce_editable' => $mce_editable,
						'content' => $this->object->content_b );
			$vars['content_b'] = cmstemplatesadmin::parse( $c_template, $c_vars );
		} elseif( $this->object->content_type == 'columns' ) {
			$c_vars = array( 'title' => ADM_CMSARTICLES_CONTENT_COL1,
						'name' => 'content_a',
						'mce_editable' => $mce_editable,
						'content' => $this->object->content_a );
			$vars['content_a'] = cmstemplatesadmin::parse( $c_template, $c_vars );
			$c_vars = array( 'title' => ADM_CMSARTICLES_CONTENT_COL2,
						'name' => 'content_b',
						'mce_editable' => $mce_editable,
						'content' => $this->object->content_b );
			$vars['content_b'] = cmstemplatesadmin::parse( $c_template, $c_vars );
		} else {
			$c_vars = array( 'title' => ADM_CMSARTICLES_CONTENT,
						'name' => 'content_b',
						'mce_editable' => $mce_editable,
						'content' => $this->object->content_b );
			$vars['content_a'] = '';
			$vars['content_b'] = cmstemplatesadmin::parse( $c_template, $c_vars );
		}
		$vars['content_type'] = cmstemplatesadmin::selectList('content_type', array( 'default' => ADM_CMSARTICLES_CONTENT_TYPE_DEFAULT, 'intro' => ADM_CMSARTICLES_CONTENT_TYPE_INTRO, 'columns' => ADM_CMSARTICLES_CONTENT_TYPE_COLUMNS ), $this->object->content_type, 'this.form.submit();' );
		return;
	}

	function updatesids($old_sid)
	{
		/* new article or article sid change */
		$sql = 'SELECT MAX( `priority` ) as priority'
		. ' FROM `'.$this->object->_tablename.'` WHERE `sid`='.$this->object->sid;

		$rs = $this->object->_db->Execute( $sql );
		$this->object->priority=$rs->Fields('priority')+1;

		if($old_sid!=$this->object->sid)
		{
			/* artikel heeft een andere sid gekregen priorities van de oude sid aanpassen */
			  
			/*
			 codestaande code komt uit db.php $this->object->delete()
			 mogelijk beter een functie creeren $this->object->update_priority_after_delete($table,$oldpriority,$oldpid / $sid)
			 */
			 
			if(isset($old_priority) && $old_priority>=0)
			{

				$sql='UPDATE `cmsarticles` SET `priority`=`priority`-1 WHERE `priority`>'.$old_priority;
				$sql.=' AND sid='.$old_sid;
				$rs = $this->object->_db->Execute($sql);
			}
			 
		}

	}

	function makealink($language, $longurl, $linktekst)
	{
		/* uit database halen, erg onefficient, maar we zitten in adminmodus */
		$sql = 'SELECT `cmsstructure`.`id`,`pid` FROM `cmsstructure` LEFT JOIN `cmsstructuretitles` ON `cmsstructure`.`id`=`cmsstructuretitles`.`sid` WHERE `language`=\''.$language.'\' AND `long_turl`="'.$longurl.'"';
		$rs = $this->object->_db->Execute($sql);
		$row = $rs->FetchRow();
		return '['.$row['pid'].';'.$row['id'].';'.$language.';'.$linktekst.']';
	}

	function adminSave( $id )
	{
		$this->object->load( $id );
		$old_sid = $this->object->sid;
		$old_content_type = $this->object->content_type;
		$this->object->bind( $_POST );

		if(empty($id) || $old_sid!=$this->object->sid)$this->updatesids($old_sid);

		/* interne links */

		$this->object->content_b = preg_replace('/<a href="'.str_replace('/','\/',CMS_BASE_URL).'([a-z]{2})(\/[^"]+)" target="_self">([^<]+)<\/a>/e',"\$this->makealink('\\1','\\2','\\3')",$this->object->content_b);
			
		$this->object->save();

		return $this->adminEdit( $id );

		if( $old_content_type <> $this->object->content_type )
		{
			return $this->adminEdit( $id );
		}
		else
		{
			return $this->adminList();
		}
	}

	function adminTranslate( $lang_pid )
	{
		$this->object->language = substr( $lang_pid, 0 ,2 );
		$this->object->pid = intval( substr( $lang_pid, 2 ) );
		return $this->object->adminEdit( 0, ADM_CMSARTICLES_CHANGEMESSAGE );
	}

	function on( $id = 0 )
	{
		if( $id ) {
			$this->object->on( $id );
			$this->object->_db->Execute( "UPDATE ".$this->object->_tablename." SET status='on' WHERE pid='".$id."'" );
			return $this->adminList( 0 );
		}
	}

	function off( $id = 0 )
	{
		if( $id ) {
			$this->object->off( $id );
			$this->object->_db->Execute( "UPDATE ".$this->object->_tablename." SET status='off' WHERE pid='".$id."'" );
			return $this->adminList( 0 );
		}
	}



	function adminDelete( $id )
	{
		$this->object->load( $id );
		$this->object->delete();
		return $this->adminList( 0 );
	}

	function adminConfirmDelete( $id )
	{
		$this->object->load( $id );
		$vars = array( 	'module' => $this->object->_tablename,
				'id' => $this->object->id,
				'title' => $this->object->title );
		return cmstemplatesadmin::show( 'delete', $this->object->_tablename, $vars );
	}

	function delete()
	{
		if( $this->object->id && $this->object->delete() ) {
			return $this->object->_db->Execute( "DELETE FROM ".$this->object->_tablename." WHERE pid='".$this->object->id."'" );
		} else {
			$this->object->_err = "Could NOT delete item";
			return FALSE;
		}
	}

	function search( $kw )
	{
		$struc = new cmsstructure( $this->object->_db );

		$rs = $this->object->_db->Execute( "SELECT a.title as title, concat( '/', '".CMS_CURRENT_LANGUAGE."', s.long_url ) as url FROM ".$this->object->_tablename." as a LEFT JOIN ".$struc->_tablename." as s ON a.sid = s.id WHERE a.language = '".CMS_CURRENT_LANGUAGE."' AND a.status='on' AND s.status='on' AND ( a.title LIKE '%".$kw."%' OR a.content_a LIKE '%".$kw."%' OR a.content_b LIKE '%".$kw."%' )" );
		if( $rs ) {
			return $rs->GetArray();
		} else {
			return FALSE;
		}
	}
}