<?
myautoload('cmsimages');


define( 'MODULE_CMSIMAGESADMIN', TRUE );

require_once( CMS_CURRENT_LANGUAGE.'.php' );

class cmsimages_admin 
{
	
	var $object;
	
	function cmsimages_admin (&$object)
	{
		$this->object=$object;
	}
	
	function check()
	{
		if( !$this->object->insert_time ) {
			$this->object->insert_time = time();
		}
		$this->object->update_time = time();
		if( $this->object->categoryid ) {
			$this->object->categoryid = intval( $this->object->categoryid );
		} else {
			$this->object->categoryid = 1;
		}
		return TRUE;
	}

	function adminList( $page = 0 )
	{
		$sql = "SELECT id, filename FROM ".$this->object->_tablename." WHERE {{where}} ORDER BY update_time DESC, id DESC";
		return cmstemplatesadmin::adminMMList( $this->object->_db, $this->object->_tablename, $sql, $page );
	}

	function showAdminSelectNav( $id )
	{
	
		myautoload('cmsimages_cmsimagescategories_admin');
		$tmp = $this->object->_tablename.'_'.$this->object->_tablename.'categories_admin';
		$cats = new $tmp($this->object->_db );
		return $cats->showAdminSelectNav( $id );
	}

	function adminEdit( $id )
	{
		if( $id ) 
		{
			$this->object->load( $id );
			
		}
		$vars = get_object_vars( $this->object );
		
		
		
		$vars['module'] = $this->object->_tablename;
		
		myautoload($this->object->_tablename.'_'.$this->object->_tablename.'categories_admin');
		$tmp = $this->object->_tablename.'categories';
		$obj = & new $tmp($this->object->_db);
		$tmp = $this->object->_tablename.'categories_admin';
		$cats = & new $tmp($obj);

		$vars['cats'] = $cats->showAdminSelect( 'categoryid', $this->object->categoryid );

		$vars['titles'] = '';
		$title_templ = cmstemplates::loadfile( 'edit_title', $this->object->_tablename );
        
		if( $id ) 
		{
		/* image tonen */
		$vars['image']=cmstemplates::show('img/img',null,array('src'=>CMS_IMAGES_SCALED_DIR.$vars['filename']));
		
		$rs = $this->object->_db->Execute( "SELECT language, title FROM ".$this->object->_titles_tablename." WHERE imageid='".$this->object->id."'" );
		$titles = $rs->GetAssoc();
		$vars['title'] = $titles[CMS_CURRENT_LANGUAGE];
		}
		else
		{
			$vars['title'] = '<em>New file</em>';
			
		}
			
			

		
		$langs = cmslanguages::getArray();
		$vars['titles'] = '';
		foreach( $langs as $lang_key => $lang_title ) 
		{
			$title_vars = array( 'name' => 'title',
						'language' => $lang_title,
						'language_key' => $lang_key );
			if( isset( $titles[$lang_key] ) ) 
			{
				$title_vars['value'] = $titles[$lang_key];
			} 
			else 
			{
				$title_vars['value'] = '';
			}
		$vars['titles'] .= cmstemplates::parse( $title_templ, $title_vars );
		}
		
		
		

		return cmstemplates::show($this->object->_tablename.'_edit', $this->object->_tablename, $vars );
	}

	function adminSave( $id )
	{
		if( $id ) {
			$this->object->load( $id );
		}
		$this->object->bind( $_POST );
		if( $_FILES['userfile']['name'] || !$this->object->filename ) {
			$succes = $this->upload();
		} else {
			$succes = TRUE;
		}
		if( $succes && $this->object->save() ) {

        		$langs = cmslanguages::getArray();
			$rs = $this->object->_db->Execute( "SELECT language, id FROM ".$this->object->_titles_tablename." WHERE imageid='".$this->object->id."'" );
			$trans = $rs->GetAssoc();
			foreach( $langs as $lang => $lang_title ) 
			{
				//$title = $this->object->_db->Quote( $_POST[ 'title_'.$lang ] );
				$title = str_replace('\'','\\\'',$_POST[ 'title_'.$lang ] );
				if( isset( $trans[ $lang ] ) ) {
					$this->object->_db->Execute( "UPDATE ".$this->object->_titles_tablename." SET title='".$title."' WHERE imageid='".$this->object->id."' AND language='".$lang."'" );
				} else {
					$this->object->_db->Execute( "INSERT INTO ".$this->object->_titles_tablename." ( imageid, language, title ) values ( '".$this->object->id."', '".$lang."', '".$title."' )" );
				}
			}

			return $this->adminList( 0 );
		} else {
			return $this->adminList( 0 );
		}
	}

	function adminDelete( $id )
	{
		$this->object->load( $id );
		if( @unlink( CMS_CLIENT_PATH.CMS_IMAGES_ORIGINAL_DIR.$this->object->filename ) ) {
			unlink( CMS_CLIENT_PATH.CMS_IMAGES_SCALED_DIR.$this->object->filename );
			unlink( CMS_CLIENT_PATH.CMS_IMAGES_THUMBS_DIR.$this->object->filename );
			if( $this->object->delete() ) {
				$this->object->_db->Execute( "DELETE FROM ".$this->object->_titles_tablename." WHERE imageid='".$id."'" );
				return $this->adminList( 0 );
			} else {
				return $this->adminList( 0 );
			}
		} else {
			return $this->adminList( 0 );
		}
	}

	function adminConfirmDelete( $id )
	{
		$this->object->load( $id );
		$vars = get_object_vars( $this->object );
		$vars['title'] = $this->object->filename;
		$vars['module'] = $this->object->_tablename.'_admin';
		return cmstemplates::show( 'delete', $this->object->_tablename, $vars );
	}

	function upload()
	{
		$resize_type = CMS_IMAGES_SCALE_TYPE;
		$originalfilename = upload( $this->object->filename, CMS_CLIENT_PATH.CMS_IMAGES_ORIGINAL_DIR, ( $this->object->id ? 'yes' : 'no' ) );

		if( $originalfilename ) {
			$this->object->filename = basename( $originalfilename );
			$scaledfilename = CMS_CLIENT_PATH.CMS_IMAGES_SCALED_DIR.$this->object->filename;
			$thumbsfilename = CMS_CLIENT_PATH.CMS_IMAGES_THUMBS_DIR.$this->object->filename;

			if( filesize( $originalfilename ) < 52428800 ) {

				if( $size = getimagesize( $originalfilename ) ) 
				{
					//it's an image
					$suc1 = resize( $originalfilename, $scaledfilename, CMS_IMAGES_SCALED_SIZE, $resize_type, CMS_IMAGES_SCALE_BLOWUP );
					$suc2 = resize( $originalfilename, $thumbsfilename, CMS_IMAGES_THUMBS_SIZE, $resize_type, CMS_IMAGES_SCALE_BLOWUP );

					if( $suc1 && $suc2 ) {
						return TRUE;
				 	} else {
						@unlink( $originalfilename );
						@unlink( $scaledfilename );
						@unlink( $thumbsfilename );
						return FALSE;
					}
				} else {
					unlink( $originalfilename );
					return FALSE;
				}
			} else {
				unlink( $originalfilename );
				return FALSE;
			}
				
		} else {
			return FALSE;
		}
	}

	function showCategory( $parent_category )
	{
        	if( isset( $_POST['category'] ) && $_POST['category'] ) {
                	$category = intval( $_POST['category'] );
        	} elseif( CMS_CURRENT_ID ) {
			$rs = $this->object->_db->Execute( "SELECT categoryid FROM ".$this->object->_tablename." WHERE id='".substr( CMS_CURRENT_ID, 2 )."'" );
			$record = $rs->FetchRow();
			$category = $record['categoryid'];
		} else {
                	$rs = $this->object->_db->SelectLimit( "SELECT id FROM ".$this->object->_cats_tablename." WHERE pid='".$parent_category."' AND status='on' ORDER BY priority, id DESC", 1 );
			$record = $rs->FetchRow();
                	$category = $record['id'];
        	}
		if( isset( $_POST['page'] ) ) {
			$page = abs( intval( $_POST['page'] ) );
       	 	} elseif( CMS_CURRENT_ID ) {
			$page = intval( substr( CMS_CURRENT_ID, 0, 2 ) ) - 10;
		} else {
			$page = 0;
        	}
		list( $cols, $rows ) = explode( 'x', CMS_IMAGES_CATEGORY_TABLE );
		$pageitems = $cols*$rows;

		$cats = new cmsimages2cats( $this->object->_db );
		$vars['select_category'] = $cats->showSelectForm( $category, $parent_category, 'category' );

		$row_templ = cmstemplates::loadfile( 'cmsimages2_category_row', $this->object->_tablename );
		$item_templ = cmstemplates::loadfile( 'cmsimages2_category_item', $this->object->_tablename );
		$itemdata_templ = cmstemplates::loadfile( 'cmsimages2_category_itemdata', $this->object->_tablename );

        	$sql  = "SELECT id, filename FROM ".$this->object->_tablename." WHERE categoryid = '".$category."' ORDER BY update_time DESC, id DESC";
        	$rs = $this->object->_db->SelectLimit( $sql, $pageitems, $page*$pageitems );
		$records = $rs->GetArray();
		$vars['rows'] = '';
		for( $row=0; $row<$rows; $row++ ) {
			$items = '';
			for( $col=0; $col<$cols; $col++ ) {
				$record = each( $records );
				if( $record ) {
					$itemvars['filename'] = $record[1]['filename'];
					if( CMS_CURRENT_ID ) {
						$itemvars['url'] = '../'.substr($page+10,0,2).$record[1]['id'].'/';
					} else {
						$itemvars['url'] = './'.substr($page+10,0,2).$record[1]['id'].'/';
					}
					$itemdata = cmstemplates::parse( $itemdata_templ, $itemvars );
				} else {
					$itemdata = '';
				}
				$items .= cmstemplates::parse( $item_templ, array( 'itemdata' => $itemdata ) );
			}
			$vars['rows'] .= cmstemplates::parse( $row_templ, array( 'items' => $items ) );
		}
		$rs	= $this->object->_db->Execute( $sql );
		$nr	= $rs->RecordCount();
		$pages	= ceil( $nr/$pageitems );
		$nav_templ = cmstemplates::loadfile( 'cmsimages2_category_nav', $this->object->_tablename );
		$nav['category'] = $category;
		
		if( $page>0 ) {
			$nav['page'] = $page-1;
			$nav['title'] = '<';
			$prev = cmstemplates::parse( $nav_templ, $nav );
		} else {
			$prev = '';
		}
		if( $pages>1 && $page < ($pages-1) ) {
			$nav['page'] = $page+1;
			$nav['title'] = '>';
			$next = cmstemplates::parse( $nav_templ, $nav );
		} else {
			$next = '';
		}
		$vars['navigation'] = $prev;
		$vars['navigation'] .= $next;
		return cmstemplates::show( 'cmsimages2_category', $this->object->_tablename, $vars );
	}

	function showCategoryImage( $parent_category )
	{
		if( CMS_CURRENT_ID ) {
			$this->object->load( intval( substr( CMS_CURRENT_ID, 2 ) ) );
		} else {
			if( isset( $_POST['category'] ) && $_POST['category'] ) {
       				$category = intval( $_POST['category'] );
			} else {
       		         	$rs = $this->object->_db->SelectLimit( "SELECT id FROM ".$this->object->_cats_tablename." WHERE pid='".$parent_category."' AND status='on' ORDER BY priority, id DESC", 1 );
				$record = $rs->FetchRow();
				$category = $record['id'];
       	 		}
			$rs = $this->object->_db->SelectLimit( "SELECT id FROM ".$this->object->_tablename." WHERE categoryid = '".$category."' ORDER BY update_time DESC, id DESC" );
			$record = $rs->FetchRow();
			$this->object->load( $record['id'] );
		}
		if( $this->object->id ) {
			$rs = $this->object->_db->Execute( "SELECT title FROM ".$this->object->_titles_tablename." WHERE imageid='".$this->object->id."' AND language='".CMS_CURRENT_LANGUAGE."'" );
			$record = $rs->FetchRow();
			$vars = get_object_vars( $this );
			$vars['title'] = $record['title'];
			return cmstemplates::show( 'cmsimages2_category_image', $this->object->_tablename, $vars );
		} else {
			return FALSE;
		}
		
	}
}
