<?php
	
/*
*/

define( 'MODULE_CMSSTRUCTURE', TRUE );

myautoload('cmsstructure_cmsstructuretitles');

class cmsstructure extends EstrateDB
{
	var	$id;

	var	$external_url;		//optionally link an item to an external URL
	var	$pid;			//parent ID

	var	$status;		//'on' or 'off'
	var	$requiredrights;	//minimal required rights to view the content of this page
	var	$priority;		//integer for sorting
	var	$description;		//meta data: description
	var	$keywords;		//meta data: keywords
	var	$body_template;
	var	$header_template;
	var	$footer_template;
	var $css;
	var	$update_time;
	var	$insert_time;
	var	$_menu_count;
	var $menu;
	var $sitemap;
	var $osmenu;

	
	//var	$witregels;
	
	var	$_titles;		//titles in all available languages will be put in an assoc. array
					//ie. $_titles['en'] = 'title'
	var	$_long_turls;				

	function cmsstructure( &$db )
	{
		EstrateDB::EstrateDB( $db );
		require_once( CMS_CURRENT_LANGUAGE.'.php' );
		myautoload('oscmsmenu');
		$this->osmenu = new  oscmsmenu($db);
	}

	function save()
	{
		$this->update_time=time();
		$succes = EstrateDB::save();

		//move to ...titles class
		if( $succes && is_array( $this->_titles ) ) 
		{	
			$struc_title = new cmsstructuretitles( $this->_db );
			
			
			
			foreach( $this->_titles as $lang=>$title ) 
			{
				
				$struc_title->language = $lang;
				$struc_title->sid = $this->id;
				$struc_title->id = 0;
				$struc_title->load();
				$struc_title->title = $title;
				$struc_title->turl = niceurl(empty($title)?($this->_titles[CMS_LANGUAGES_DEFAULT]):$title);
				$struc_title->long_turl = $this->getFullURL($struc_title->turl,$lang);
				$struc_title->save();
			}
	
		}

		return $succes;
	}

	function bind( $array ) {
		EstrateDB::bind( $array );

		//move to ...titles class
		$lang = new cmslanguages();
		$languages = $lang->getArray();
		foreach( $languages as $lang => $lang_title ) {
			if( isset( $_POST['title_'.$lang] ) ) {
				$this->_titles[$lang] = $_POST['title_'.$lang];
			}
		}
	}
	
	function getFullURL($turl,$language=CMS_LANGUAGES_DEFAULT)
	{
		if( $turl ) {
			if(!empty($turl))$url[] = $turl;

			$pid = $all_pids[] = $this->pid;
			while ( $pid ) {
				$sql = 'SELECT `turl`, `pid` FROM `'.$this->_tablename.'` LEFT JOIN `cmsstructuretitles` ON `'.$this->_tablename.'`.`id`=`cmsstructuretitles`.`sid` WHERE `'.$this->_tablename.'`.`id` = '.$pid.' AND `language`=\''.$language.'\'';
				$rs = $this->_db->Execute( $sql );
				
				/* er moet iets uit komen */
				if(!$rs->RecordCount())
				{
					$sql = 'SELECT `turl`, `pid` FROM `'.$this->_tablename.'` LEFT JOIN `cmsstructuretitles` ON `'.$this->_tablename.'`.`id`=`cmsstructuretitles`.`sid` WHERE `'.$this->_tablename.'`.`id` = '.$pid.' AND `language`=\''.CMS_LANGUAGES_DEFAULT.'\'';
				    $rs = $this->_db->Execute( $sql );
				}	
				if(!$rs->RecordCount())
				{
					$sql = 'SELECT `turl`, `pid` FROM `'.$this->_tablename.'` LEFT JOIN `cmsstructuretitles` ON `'.$this->_tablename.'`.`id`=`cmsstructuretitles`.`sid` WHERE `'.$this->_tablename.'`.`id` = '.$pid.' AND `turl`<>\'\'';
				    $rs = $this->_db->Execute( $sql );
				}	
				
				$parent = $rs->FetchRow();
				$pid = $parent['pid'];
				if( array_search( $pid, $all_pids ) === FALSE ) {
					if(!empty($parent['turl']))$url[] = $parent['turl'];
					$all_pids[] = $pid;
				} else {
					//loop detected, exit "while"
					$pid = FALSE;
				}
			}

			if(empty($url[0]))return '';
			return '/'.implode('/',array_reverse($url)).'/';
		} else {
			return '';
		}
	}

	function setAllFullURL()
	{
		
		$sql = 'SELECT `pid`,`cmsstructuretitles`.`id`,`language` FROM `cmsstructuretitles` LEFT JOIN `cmsstructure` ON `cmsstructuretitles`.`sid`=`cmsstructure`.`id`';

		$rs = $this->_db->Execute( $sql );
		if( $rs ) while( $record = $rs->FetchRow() ) 
		{
			$titles = new cmsstructuretitles( $this->_db );
			$titles->load( $record['id'] );
			
			if(!empty($titles->turl))
			{
			$this->pid=$record['pid'];	
			$sql = 'UPDATE `'.$this->_tablename.'titles` SET `long_turl` = \''.$this->getFullURL($titles->turl,$record['language']).'\' WHERE `id` ='.$record['id'];
			$this->_db->Execute( $sql );
			}
			
		}

	}

	function load( $id = 0,$and='') {
		if( $id || $id===0) {
			$this->id = $id;
		}
		$r=EstrateDB::load( $this->id, $and);
		$titles = new cmsstructure_cmsstructuretitles( $this->_db );
		//$this->_titles = $titles->loadBySid( $this->id );
		//$this->_long_turls = $titles->loadBySid( $this->id, 'long_turl' );
		
		if($this->id>0)list($this->_titles,$this->_long_turls)=array_values($titles->loadBySid( $this->id, array('title','long_turl' )));
		return $r;
	}
	
	function loadByURL( $long_url )
	{
		return;
		if(defined('structid'))
		{
		$this->load( structid );
		return structid;
		}
		
		/* alleen nodig als cache/cmsstructure niet gevuld is */
		else 
		{
			if( $long_url ) {
			if( substr( $long_url, 0, 1 ) <> '/' ) {
				$long_url = '/'.$long_url;
			}
			if( substr( $long_url, -1, 1 ) <> '/' ) {
				$long_url.= '/';
			}
			$sql = 'SELECT `id` FROM `'.$this->_tablename.'` WHERE `long_url`=\''.$long_url.'\' AND status=\'on\'';
			//echo $sql;
			$rs = $this->_db->Execute();
			$id = $rs->FetchRow();
			$this->load( $id['id'] );
			return $id['id'];
		} else {
			return FALSE;
		}	
		}	
	
	}	

	function getPathIds( )
	{
		$result[] = $this->id;
		if( $this->pid ) {
			$pid = $result[] = $this->pid;
			while( $pid ) {
				$rs = $this->_db->Execute( "SELECT pid FROM ".$this->_tablename." WHERE id='".$pid."'" );
				if( $rs->RecordCount() ) {
					$record = $rs->FetchRow();
					if( $pid = $record['pid'] ) {
						$result[] = $pid;
					}
				} else {
					$pid = FALSE;
				}
			}
		}
		return array_reverse( $result );
	}	
	
	function getPath()
	{
		

		$resultstart[CMS_BASE_URL] = CMS_BREADCRUMBS_HOME_TITLE;
		if($this->id==CMS_DEFAULT_PAGE) return $resultstart;
		$result[$this->long_url] = $this->_titles[CMS_CURRENT_LANGUAGE];
		if( $this->pid ) {
			$pid = $this->pid;
			while( $pid ) {
				$sql='SELECT pid,title,long_url FROM `'.$this->_tablename.'` LEFT JOIN `cmsstructuretitles` ON  `'.$this->_tablename.'`.`id`=`cmsstructuretitles`.`sid` WHERE `'.$this->_tablename.'`.`id`='.$pid.' AND language=\''.CMS_CURRENT_LANGUAGE.'\'';
	
				$rs = $this->_db->Execute($sql);
				if( $rs->RecordCount() == 1 && $pid!=CMS_DEFAULT_PAGE) 
				{
					
					$record = $rs->FetchRow();
					$pid = $record['pid']; 
					$result[$record['long_url']] = $record['title'];
				}
				else $pid=false; 
			}
		}
		$result=array_merge($result,$resultstart);
		return array_reverse( $result );
	}
	
	
	
	
	
	
	function sitemap($start)
	{
		return $this->osmenu->sitemap($start);
		//return $this->showMenuLevel(0,0,0,0,'expand',true);
	}
	
	function showMenuLevel($fold=1,$sid=-1,$pid=-1,$pretemp='',$max=0)
	{
		if($sid > -1)return $this->osmenu->show($fold,$sid,$pid,$pretemp,$max);
		return $this->osmenu->show($fold);
		
	}
	
	function showBreadcrumbs()
	{
		/* ivm met oude pagina's */
     	if (!defined('structid'))
		{
		define('structpid',0);
		define('structid',CMS_DEFAULT_PAGE);
		}
	return $this->osmenu->breadcrumbs();
	}
	
	function getMenuArray( $pid, $language,$sitemap=false)
	{
		$st = new cmsstructuretitles( $this->_db );
		 $sql = 'SELECT s.id, s.long_url, st.title, s.external_url'
        . ' FROM ' . $this->_tablename. ' AS s'
        . ' LEFT JOIN ' . $st->_tablename. ' AS st ON s.id = st.sid'
        . ' WHERE s.status = \'on\' AND s.pid = \''.$pid.'\' AND st.language = \''.$language.'\'';
        if(!$sitemap) $sql.= ' AND s.menu = \'show\'';
        $sql.= ' ORDER BY s.priority, st.title';
		

		$rs = $this->_db->Execute($sql);
		return $rs->GetArray();
	}
	
		function check() 
		{
		
		$this->id = intval( $this->id );
		$this->pid = intval( $this->pid );
		if( $this->pid == $this->id ) $this->pid == 0; //simple loop detection, the input form prevents any real loops
		
		if( !empty( $this->_titles[CMS_LANGUAGES_DEFAULT] ) ) {
			$url = $this->_titles[CMS_LANGUAGES_DEFAULT];
		} elseif( !empty( $this->_titles[CMS_CURRENT_LANGUAGE] ) ) {
			$url = $this->_titles[CMS_CURRENT_LANGUAGE];
		} else {
			$url = 'no-title';
		}
		
		return true;
		
	}

	function delete()
	{
		if( $this->id && EstrateDB::delete() ) {
			$titles = new cmsstructuretitles( $this->_db );
			return $titles->deleteBySid( $this->id );
		} else {
			return FALSE;
		}
	}
}
?>