<?
myautoload('cmstemplates');
class cmstemplatesadmin extends cmstemplates
{
	
function AdminList_status( $rec, $field='status') {
		if( isset( $rec['startshow'] ) ) {
			if( $rec[$field] == 'on' ) {
				if( $rec['startshow'] && $rec['startshow']>= time() ) {
					$vars[$field.'_action'] = 'off';
					$vars[$field.'_icon'] = 'scheduled';
					$vars[$field.'_msg'] = ADM_SCHEDULED;
				} elseif( $rec['stopshow'] && $rec['stopshow'] < time() ) {
					$vars[$field.'_action'] = 'off';
					$vars[$field.'_icon'] = 'expired';
					$vars[$field.'_msg'] = ADM_EXPIRED;
				} else {
					$vars[$field.'_action'] = 'off';
					$vars[$field.'_icon'] = 'ok';
					$vars[$field.'_msg'] = ADM_TURNOFF;
				}	
			} else {
				$vars[$field.'_action'] = 'on';
				$vars[$field.'_icon'] = 'no';
				$vars[$field.'_msg'] = ADM_TURNON;
			}
		} else {
			if( isset( $rec[$field] ) && $rec[$field] == 'on' ) {
				$vars[$field.'_action'] = 'off';
				$vars[$field.'_icon'] = 'ok';
				$vars[$field.'_msg'] = ADM_TURNOFF;
			} else {
				$vars[$field.'_action'] = 'on';
				$vars[$field.'_icon'] = 'no';
				$vars[$field.'_msg'] = ADM_TURNON;
			}
		}
		return $vars;
	}

	function adminSingleList( &$db, $module, $table, $sql, $pid=0, $page = 0, $items_page = 20, $breadcrumbs='',$updown=0,$sid=0 )
	{
		/*
		Single-table-style admin-list (translations point to parent)
		The table should have id, pid (parent id) and langauge fields to work.
		This way of working, is used by cmsarticles and cmsnews (and maybe more),
		is should be beter to remove this behaviour and separate language specific
		content from the main table.

		$module should contain the name of the module/table
		$sql is an SQL statement without LIMIT which should return records without records with pid:
			id : id (of default language)
			title : title (of default language)
			lang : array of available languages and their id's
			status : 'on' or 'off'
			(startshow : timestamp)
			(stopshow : timestamp)
			
		$items_page items per page, defaults to 20, 0 = indef.
		*/
		$moduletpl = str_replace('_','/',$module);
		$tpl_main 	= cmstemplatesadmin::loadfile( 'adminlist', $moduletpl );
		$tpl_legenda 	= cmstemplatesadmin::loadfile( 'adminlist_leg', $moduletpl );
		$tpl_row 	= cmstemplatesadmin::loadfile( 'adminlist_row', $module );
		$tpl_language 	= cmstemplatesadmin::loadfile( 'adminlist_lang', $moduletpl );

		//get translation id's
                
				$sql2= 'SELECT concat( language, pid ) as idkey, id FROM '.$table.' WHERE pid';

				$rs = $db->Execute( $sql2 );
				$subrecords = $rs->GetAssoc();
	
		$languages = cmslanguages::getArray();

		$rs = $db->Execute( $sql );
		$total_items = $rs->RecordCount();
		if( $items_page ) {
			$total_pages = ceil( $total_items / $items_page );
		}
		if( ! $total_pages ) {
			$total_pages = 1;
		}
		if( $rs && $total_pages > 1 ) {
			$rs = $db->SelectLimit( $sql, $items_page, $page * $items_page );
		}
		$rows = '';
		$i=1;

		while( $rs && $rec = $rs->FetchRow() ) 
		{
			$vars = array(
				'module'	=> $module,
				'id'		=> $rec['id'],
				'title'		=> $rec['title'],
				'pid'		=> $pid
			);
			
			if(isset($rec['sid']))$vars['sid']=$rec['sid'];
				
         
			$vars = array_merge( $vars, cmstemplatesadmin::adminList_status( $rec ) );
			
			if($updown)
			{
			$tpl_updown_links = cmstemplates::loadfile( 'admin_updownlink','cmstemplates' );
			
			$rec['module']=$module;
					
			if($i==1)$vars['uplink']='&nbsp;';
			else $vars['uplink']=cmstemplates::parse( $tpl_updown_links, array_merge($rec,array('what'=>'up')) );
			
			if($i==$rs->RecordCount())$vars['downlink']='&nbsp;';
			else $vars['downlink']=cmstemplates::parse( $tpl_updown_links, array_merge($rec,array('what'=>'down')) );
			}
			else 
			{
				$vars['uplink']='&nbsp;';
				$vars['downlink']='&nbsp;';
			}	
			
			
			$vars['language_template'] = '';
			foreach( $languages as $lang => $langtitle ) {
				if( $lang == $rec['language'] ) {
					$lang_vars['id'] = $rec['id'];
				} elseif( isset( $subrecords[ $lang.$rec['id'] ] ) ) {
					$lang_vars['id'] = $subrecords[ $lang.$rec['id'] ];
				} else {
					$lang_vars['id'] = $lang.$rec['id'];
				}
				$lang_vars['title'] = $langtitle;
				$lang_vars['language'] = $lang;
				$lang_vars['module'] = $module;
				$vars['language_template'] .= cmstemplatesadmin::parse( $tpl_language, $lang_vars );
			}
			$rows.= cmstemplatesadmin::parse( $tpl_row, $vars );
		$i++;	
		}
		$vars = array(
			'rows'	=> $rows,
			'module' => $module,
			'page_title' => constant( strtoupper( 'ADM_'.$module.'_TITLE' ) ),
			'explain' => constant( strtoupper( 'ADM_'.$module.'_EXPLAIN' ) ),
			'legenda' => cmstemplatesadmin::parse( $tpl_legenda, '' ),
			'pid'=>$pid,
			'breadcrumbs'=>$breadcrumbs,
			'sid'=>$sid
		);
		if( $items_page ) {
			$nav_vars = array(
				'module' => $module,
				'previous' => intval( $page ? $page-1 : $page),
				'next'	=> intval( ($page+1) < $total_pages ? $page+1 : $page ),
				'last' => $total_pages-1,
				'total_items' => $total_items,
				'page' => $page + 1,
				'total_pages' => $total_pages
			);
			$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $module );
			$vars['navigation'] = cmstemplatesadmin::parse( $tpl_navigation, $nav_vars );
		} else {
			$vars['navigation'] = '';
		}

		return cmstemplatesadmin::parse( $tpl_main, $vars );
	}

	function adminMMList( &$db, $module, $sql, $page = 0, $items_page = 10)
	{

		/*
		Multimedia-style admin-list
		$sql should contain {{where}} after the WHERE clause
		*/
		
		if( isset( $_POST['nav_catid'] ) ) {
                        $nav_catid = $_SESSION['nav_catid'] = intval( $_POST['nav_catid'] );
                } elseif( isset( $_SESSION['nav_catid'] ) ) {
                        $nav_catid = $_SESSION['nav_catid'];
                } else {
			$nav_catid = 0;
		}
		
		/* let op! onderscheid naar module niet nodig, templates kunnen in cmsphotos staan
		NU wel handig ivm met leeg scherm
		*/
		
		if( $module == 'cmsphotos')
		{
		if($nav_catid==0)$tpl_main = cmstemplatesadmin::loadfile( 'adminmmlist_photos_empty', $module );
		else $tpl_main 	= cmstemplatesadmin::loadfile( 'adminmmlist_photos', $module );
		$tpl_row 	= cmstemplatesadmin::loadfile( 'adminmmlist_row_photos', $module ); 
		}
		else 
		{
		$tpl_main 	= cmstemplatesadmin::loadfile( 'adminmmlist', $module );
		$tpl_row 	= cmstemplatesadmin::loadfile( 'adminmmlist_row', $module );
		}
		
		$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $module );

		if( $nav_catid ) {
			$sql = str_replace( '{{where}}', " categoryid='".$nav_catid."' ", $sql );
		} else {
			$sql = str_replace( '{{where}}', " 1 ", $sql );
			//if( $module == 'cmsphotos') $sql='';
		}

		$rs = $db->Execute( $sql );
		if( $rs ) {
			$total_items = $rs->RecordCount();
		} else {
			$total_items = 0;
		}
		if( !$nav_catid ) {

			$total_pages = ceil( $total_items / $items_page );
			$rs = $db->SelectLimit( $sql, $items_page, 0 );
		} elseif( $items_page ) {
			$total_pages = ceil( $total_items / $items_page );
			$rs = $db->SelectLimit( $sql, $items_page, $page * $items_page );
		}
		if( ! $total_pages ) {
			$total_pages = 1;
		}
		$row = '';
		$i=1;
		while( $rs && $rec = $rs->FetchRow() ) 
		{
			$rec['module'] = $module;
			$rec = array_merge( $rec, cmstemplatesadmin::adminList_status( $rec ) );
			if((defined('CMS_MODULETYPE') && CMS_MODULETYPE=='image') || $module == 'cmsimages' || $module == 'cmsimages2' || $module == 'cmsphotos' || $module == 'cmsphotobook') 
			{
				$size = getimagesize( CMS_CLIENT_PATH.CMS_IMAGES_ORIGINAL_DIR.$rec['filename'] );
				$rec['original'] = $size[0].'x'.$size[1];
				$size = getimagesize( CMS_CLIENT_PATH.CMS_IMAGES_SCALED_DIR.$rec['filename'] );
				$rec['scaled'] = $size[0].'x'.$size[1];
				$size = getimagesize( CMS_CLIENT_PATH.CMS_IMAGES_THUMBS_DIR.$rec['filename'] );
				$rec['thumbs'] = $size[0].'x'.$size[1];
			} elseif ( $module == 'cmsmediaportal' ) {
				$rec['original'] = ADM_ORIGINAL;
				if( file_exists( $file = CMS_CLIENT_PATH.CMS_MEDIAPORTAL_SCALED_DIR.$rec['filename'].'.png' ) ) {
					$size = getimagesize( $file );
					$rec['scaled'] = $size[0].'x'.$size[1];
				} else {
					$rec['scaled'] = ADM_MISSING;
				}
				if( file_exists( $file = CMS_CLIENT_PATH.CMS_MEDIAPORTAL_THUMBS_DIR.$rec['filename'].'.png' ) ) {
					$size = getimagesize( $file );
					$rec['thumbs'] = $size[0].'x'.$size[1];
					$rec['icon'] = '/'.CMS_MEDIAPORTAL_THUMBS_DIR.$rec['filename'].'.png';
				} else {
					$rec['thumbs'] = ADM_MISSING;
					$rec['icon'] = CMS_BASE_URL.CMS_ADMIN_ICONS_URL.'48x48/'.type2icon( $rec['type'] ).'.png';
				}
			} elseif( $module == 'cmsdownloads' || $module == 'cmsmegadownloads' ) {
				$rec['icon'] = CMS_BASE_URL.CMS_ADMIN_ICONS_URL.'48x48/'.type2icon( $rec['type'] ).'.png';	
			}

			if( $module == 'cmsphotos')
			{
			$rec = array_merge( $rec, cmstemplatesadmin::adminList_status( $rec ) );	
			$tpl_updown_links = cmstemplates::loadfile( 'admin_updownlink','cmstemplates' );
					
			if($i==1)$rec['uplink']='&nbsp;';
			else $rec['uplink']=cmstemplates::parse( $tpl_updown_links, array_merge($rec,array('what'=>'up')) );
			
			if($i==$rs->RecordCount())$vars['downlink']='&nbsp;';
			else $rec['downlink']=cmstemplates::parse( $tpl_updown_links, array_merge($rec,array('what'=>'down')) );
			}
			else 
			{
				$rec['uplink']='&nbsp;';
				$rec['downlink']='&nbsp;';
			}	
			
			
			$row .= cmstemplatesadmin::parse( $tpl_row, $rec );
		$i++;	
		}
		$vars['rows'] = $row;
		$adminmodule=$module.'categories_admin';
		myautoload($module.'_'.$module.'categories');
		myautoload($module.'_'.$adminmodule);
		$mod = $module.'categories';
		$obj = & new $mod($db);
		$mod = & new $adminmodule( $obj );
		

		$vars['select_nav'] = $mod->showAdminSelectNav( $nav_catid);
		$vars['module'] = $module;
		$vars['page_title'] = constant( strtoupper( 'ADM_'.$module.'_TITLE' ) );
		$vars['explain'] = constant( strtoupper( 'ADM_'.$module.'_EXPLAIN' ) );
		if( $items_page && $nav_catid ) {
			$nav_vars = array(
				'module' => $module,
				'previous' => intval( $page ? $page-1 : $page),
				'next'	=> intval( ($page+1) < $total_pages ? $page+1 : $page ),
				'last' => $total_pages-1,
				'total_items' => $total_items,
				'page' => $page + 1,
				'total_pages' => $total_pages
			);
			$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $module );
			$vars['navigation'] = cmstemplatesadmin::parse( $tpl_navigation, $nav_vars );
		} else {
			$vars['navigation'] = '';
		}
		return cmstemplatesadmin::parse( $tpl_main, $vars );
	}

	function adminHierarchyList( &$db, $module, $sql, $page = 0, $items_page = 20  ,$pid=0,$updown=false,$vars=array(),$extraid=0)
	{
		global $hierarchy_level;
		/*
		Hierarchal-style admin-list (ie. categories, tree-like-structures)

		SQL string should contain "WHERE {{pid}}"
		{{pid}} will be replaced by pid='<x>' or 1=1
		*/
		$vars['pid'] = $pid;
		$vars['extraid']=$extraid;
		

		$tpl_main 	= cmstemplatesadmin::loadfile( 'adminhlist'.($updown?'updown':''), str_replace(array('_admin','_'),array('','/'),$module) );
		$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $module );
		$tpl_legenda 	= cmstemplatesadmin::loadfile( 'adminlist_leg', $module );
		$tpl_language 	= cmstemplatesadmin::loadfile( 'adminlist_lang', $module );

		$sql_total = str_replace( '{{pid}}', '1=1', $sql );

		$rs = $db->Execute( $sql_total );
		if( $rs ) {
			$total_items = $rs->RecordCount();
		} else {
			$total_items = 0;
		}
		if( isset( $items_page ) && $items_page ) {
			$total_pages = ceil( $total_items / $items_page );
		}
		if( ! isset( $total_pages ) ) {
			$total_pages = 1;
		}
		$hierarchy_level == 0;
		$vars['module'] = $module;
		$vars['rootmodule'] = substr($module,0,strpos($module,'_'));
		$vars['page_title'] = constant( strtoupper( 'ADM_'.$module.'_TITLE' ) );
		$vars['explain'] = constant( strtoupper( 'ADM_'.$module.'_EXPLAIN' ) );
		$vars['legenda'] = cmstemplatesadmin::parse( $tpl_legenda, '' );

		$vars['rows'] = cmstemplatesadmin::adminHList_row( $db, $module,$sql, $page, $items_page, 0, $updown);
		if( $items_page ) {
			$nav_vars = array(
				'module' => $module,
				'previous' => intval( $page ? $page-1 : $page),
				'next'	=> intval( ($page+1) < $total_pages ? $page+1 : $page ),
				'last' => $total_pages-1,
				'total_items' => $total_items,
				'page' => $page + 1,
				'total_pages' => $total_pages
			);
			//$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $module );
			$vars['navigation'] = cmstemplatesadmin::parse( $tpl_navigation, $nav_vars );
		} else {
			$vars['navigation'] = '';
		}
		
		return cmstemplatesadmin::parse( $tpl_main, $vars );
	}
	
	
	
	function adminHList_row( &$db, $module,$sql, $page, $items_page, $pid = 0, $updown=false)
	{
		global $hierarchy_level;
		
		$tpl_row = cmstemplatesadmin::loadfile( 'adminhlist_row', str_replace('_','/',$module) );
		
		
		$rows = '';

		$level_sql = str_replace( '{{pid}}', " pid='".$pid."' ", $sql );
		if($hierarchy_level>0)$level_sql = str_replace( 'DESC', 'ASC', $level_sql );
		if( $items_page ) {
			$rs = $db->SelectLimit( $level_sql, $items_page, $page * $items_page );
		} else {
			$rs = $db->Execute( $level_sql );
		}
		$row = '';
		if( $rs && $rs->RecordCount() ) {
			$hierarchy_level++;
			$i=1;
			while( $rec = $rs->FetchRow() ) {
				$rec['module'] = $module;
				$rec['level'] = ($hierarchy_level-1) * 20;
				$rec = array_merge( $rec, cmstemplatesadmin::adminList_status( $rec ) );
					
				if($updown)
				{
				$tpl_updown_links = cmstemplatesadmin::loadfile( 'admin_updownlink', $module );		
				$tpl_rowupdown = cmstemplatesadmin::loadfile( 'adminhlist_rowupdown', $module );
				if($i==1)$rec['uplink']='&nbsp;';
				else $rec['uplink']=cmstemplatesadmin::parse( $tpl_updown_links, array_merge($rec,array('what'=>'up')) );
			
				if($i==$rs->RecordCount())$rec['downlink']='&nbsp;';
				else $rec['downlink']=cmstemplatesadmin::parse( $tpl_updown_links, array_merge($rec,array('what'=>'down')) );
			    $row .= cmstemplatesadmin::parse( $tpl_rowupdown, $rec );
				}
				else 
				{
				$row .= cmstemplatesadmin::parse( $tpl_row, $rec );
				}
				$row .= cmstemplatesadmin::adminHList_row( $db, $module,$sql, $page, $items_page, $rec['id'],$updown);
			$i++;
			}
			$hierarchy_level--;
		}
		return $row;
	}

	function adminSimpleList( &$db, $module, $sql, $page = 0, $items_page = 20,$updown = false )
	{
		/*
		Simple-style admin-list (ie. contactforms, mailforms, weblog)
		*/
		
		$templatedir = str_replace('_','/',$module);
		
		
		if($updown)
		{
			$tpl_main 	= cmstemplatesadmin::loadfile( 'adminhlistupdown', $templatedir );
			$tpl_row 	= cmstemplatesadmin::loadfile( 'adminhlist_rowupdown', $templatedir );
		    $tpl_updown_links = cmstemplates::loadfile('admin_updownlink', $templatedir );
		}
		else
		{
			$tpl_main 	= cmstemplatesadmin::loadfile( 'adminsimplelist', $templatedir );
		    $tpl_row 	= cmstemplatesadmin::loadfile( 'adminhlist_row', $templatedir );
		}
		$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $templatedir );
		$tpl_legenda 	= cmstemplatesadmin::loadfile( 'adminlist_legsimple', $templatedir );
		
		

		$rs = $db->Execute( $sql );
		if( $rs ) {
			$total_items = $rs->RecordCount();
		} else {
			$total_items = 0;
		}
		if( $items_page ) {
			$total_pages = ceil( $total_items / $items_page );
			$rs = $db->SelectLimit( $sql, $items_page, $page * $items_page );
		}
		if( ! $total_pages ) {
			$total_pages = 1;
		}
		$row = '';
		$i=1;
		while( $rs && $rec = $rs->FetchRow() ) {
			$rec['module'] = $module;
			
			
			if($updown)
		    {
			if($i==1)$rec['uplink']='&nbsp;';
            else $rec['uplink']=cmstemplates::parse( $tpl_updown_links,array_merge($rec,array('what'=>'up')) );
            if($i==$rs->RecordCount())$rec['downlink']='&nbsp;';
            else $rec['downlink']=cmstemplates::parse( $tpl_updown_links,array_merge($rec,array('what'=>'down')) );
		    }
			
			
			$rec = array_merge( $rec, cmstemplatesadmin::adminList_status( $rec ) );
			$row .= cmstemplatesadmin::parse( $tpl_row, $rec );
			$i++;
		}
		$vars['rows'] = $row;
		$vars['module'] = $module;
		$vars['page_title'] = constant( strtoupper( 'ADM_'.$module.'_TITLE' ) );
		$vars['explain'] = constant( strtoupper( 'ADM_'.$module.'_EXPLAIN' ) );
		$vars['legenda'] = cmstemplatesadmin::parse( $tpl_legenda, '' );
		if( $items_page ) {
			$nav_vars = array(
				'module' => $module,
				'previous' => intval( $page ? $page-1 : $page),
				'next'	=> intval( ($page+1) < $total_pages ? $page+1 : $page ),
				'last' => $total_pages-1,
				'total_items' => $total_items,
				'page' => $page + 1,
				'total_pages' => $total_pages
			);
			$tpl_navigation	= cmstemplatesadmin::loadfile( 'adminlist_nav', $module );
			$vars['navigation'] = cmstemplatesadmin::parse( $tpl_navigation, $nav_vars );
		} else {
			$vars['navigation'] = '';
		}
		return cmstemplatesadmin::parse( $tpl_main, $vars );
	}

	function selectList( $name, $records, $selected, $onchange='')
	{

		$templ = cmstemplatesadmin::loadfile( 'selectlist', 'cmstemplates' );
		$row = cmstemplatesadmin::loadfile( 'selectrow', 'cmstemplates' );
		$rows = '';
		if( is_array( $records ) ) foreach( $records as $key => $value ) {
			$vars = array( 'key' => $key, 'value' => $value );
			if( $key == $selected ) {
				$vars['selected'] = ' selected="selected" ';
			} else {
				$vars['selected'] = '';
			}
			$rows .= cmstemplatesadmin::parse( $row, $vars );
		}
		$vars = array( 'name' => $name, 'rows' => $rows,'onchange'=>$onchange);
		if( $rows ) return cmstemplatesadmin::parse( $templ, $vars );
	}
	
	function navigation($page,$total_items,$total_pages,$module,$extrapars='')
	{
			

		
		
		$nav_vars = array(
				'module' => $module,
				'previous' => intval( $page ? $page-1 : $page),
				'next'	=> intval( ($page+1) < $total_pages ? $page+1 : $page ),
				'last' => $total_pages-1,
				'total_items' => $total_items,
				'page' => $page + 1,
				'total_pages' => $total_pages,
				'extrapars' => $extrapars
				
			);
			
		
		
			$tpl_navigation	= cmstemplates::loadfile( 'adminlist_nav', $module );
	
			if($total_pages>1)
			{
			$pagenumbering = '';
			$tpl_pagenumbering	= cmstemplates::loadfile('pagenumbering_link',null,null);
			$max=min($total_pages,max(10,$page+5));
			for($i=max(0,min($total_pages-10,$page-5)); $i<$max; $i++)
			{
				if($i == $page)
				{
					$pagenumbering .= ($i+1);	
				}	
				else 
				{
					/* links maken */
					//var_dump(array_merge($nav_vars,array('iterator'=>$i))); exit;
					$pagenumbering .= cmstemplates::parse($tpl_pagenumbering,array_merge($nav_vars,array('iterator'=>($i),'tekst'=>($i+1))));
				}	
				
				if($i<($max-1)) $pagenumbering .= '&nbsp;|&nbsp;';	
			}	
			
			$nav_vars['pagenumbering'] = $pagenumbering;
			if($page>0)$nav_vars['previousblock'] = cmstemplates::show('adminlist_previous' ,null, $nav_vars );
			if($total_pages>$page)$nav_vars['nextblock'] = cmstemplates::show('adminlist_next' ,null, $nav_vars );
						
			return cmstemplates::parse( $tpl_navigation, $nav_vars );
		} 
		else 
		{
			return '';
		}
		
		
}
}
