<?php
defined( 'OSC_SECURE' ) or die( 'Restricted access' );
/*

*/

class EstrateDB
{
	// Database connection object
	var $_db;

	// Tablename
	var $_tablename;

	// Name of primary key
	var $_tablekey = 'id';
	
	// Error messages if a function returns FALSE
	var $_error = FALSE;
	
	/*
	function EstrateDB( &$db=null, $key = 'id' )
	aangepast 26-06-07 
	*/
	function EstrateDB( &$db, $key = 'id' )
	{
		$this->_tablename			= strtolower(str_replace(array('_admin','admin'),'',get_class( $this )));
		if( $key )	$this->_tablekey	= $key;
		if( $db )	$this->_db 		= $db;
	}
	
	function Error()
	{
		if ($this->_error) {
			return $this->_error;
		} else {
			return NULL;
		}
	}
	
	function get($name,$id=null)
	{
		if (isset($this->$name))
		{
			return $this->$name;
		} else 
		{
			if(!is_null($id))
			{
				$this->load($id);
				return $this->$name;
			}	
			return NULL;
		}
	}

	function set($name, $value)
	{
		$this->$name = $value;
	}

	function load($id=NULL,$and='')
	{

		
		$tk = $this->_tablekey;

		if ($id || $id===0)
		{
			$this->$tk = $id;	
		} else {
			$id = $this->$tk;
		}

		if (!isset($id)) return false;
		
		$sql=$this->loadquery($id,$and);

		$rs = $this->_db->Execute($sql);

		if ($rs === FALSE ) {
			$this->_error = $this->_db->ErrorMsg();
			//echo $this->Error(); 
		} 
		else {
			$this->bind($rs->fetchRow());
			return TRUE;
		}
	}
	
	function loadquery($id=NULL,$and='')
	{
		$sql='SELECT * FROM '.$this->_tablename.' WHERE '.$this->_tablekey.'=\''.$id.'\'';
  		if(!empty($and)) $sql.=' AND '.$and;
  		return $sql;
	}	
	
	//inserts or updates object in DB, depending on the existence of an id
	function save($update_nulls=false,$check=true)
	{

		if (($check && $this->check()) || !$check) {
			$tk = $this->_tablekey;

			if ($this->$tk) {
				return $this->update($update_nulls);
			} else {
				return $this->insert();
			}
		} else {
			return FALSE;
		}
	}

	function insert()
	{
		    $vars = get_object_vars($this);
			
		    /* voor php > 5 
		    
		    array_key_exists kan vervangen worden door property_exists
		    
		    isset geeft false voor property die op null staat
		    
		    */
		    
		    if(array_key_exists('priority',$vars) && empty($this->priority))
			{
				
				$sql = 'SELECT MAX(`priority`) AS max FROM `'.$this->_tablename.'`';

				if
				(
				array_key_exists('pid',$vars) && isset($this->pid)
				) 
				$sql .= ' WHERE `pid`='.$this->pid;
				
				$rs = $this->_db->Execute($sql);
				$this->priority = $vars['priority'] = $rs->Fields('max')+1;
				
			}
			if(array_key_exists('insert_time',$vars))
			{
				
				if(is_null($vars['insert_time']))
				$vars['insert_time']=time();
			}
			if(array_key_exists('update_time',$vars))
			{
				
				if(is_null($vars['update_time']))
				$vars['update_time']=time();
			}
	
		
		foreach ($vars as $key=>$value) 
		{
			if (isset($this->$key) && $key[0]<>'_' && !is_object($value)) 
			{	
				
				/* let op !is_object()
				vreemd dat er een object tussen kan zitten?
				*/
				if (is_array($value)) {
					$value = implode(', ',$value);
				}
				$fields[]='`'.$key.'`';
				//$values[]=$this->_db->Quote($value);
				//$values[]='\''.str_replace('\'','\\\'',$value).'\'';
				$values[]=$this->_db->quote($value);
			}
		}
		
		$sql='INSERT INTO `'.$this->_tablename.'` ( '.implode(', ',$fields).' ) values ( '.implode(', ',$values).' )';
//echo $sql.'<br />';exit;
		$rs = $this->_db->Execute($sql);

		if ($rs === FALSE) {
			die('Query failed: ' .$sql. mysql_error());
			return FALSE;
		} else {
			$tk = $this->_tablekey;
			$this->$tk = $this->_db->insert_id();
			
			
			return TRUE;
		}
	}

	function update($update_nulls = FALSE)
	{
			$vars = get_object_vars($this);
			if(array_key_exists('update_time',$vars))
			{
				
				if(is_null($vars['update_time']))
				$vars['update_time']=time();
			}
		
		foreach ($vars as $key=>$value) {
			if (isset($this->$key) && $key[0]<>'_' && !is_object($value)) {
				if (is_array($value)) {
					$value = implode(', ',$value);
				}
				$fieldsvalues[]="`".$key."`=".$this->_db->quote($value);
			}
		}
		$tk = $this->_tablekey;	
		$sql= 'UPDATE `'.$this->_tablename.'` SET '.implode(', ',$fieldsvalues).' WHERE `'.$this->_tablekey.'`="'.$this->$tk.'"';
//echo $sql.'<br />'; exit;		

		$rs = $this->_db->Execute($sql);
		if ($rs === FALSE) {
			$this->_error = $this->_db->ErrorMsg();
			return FALSE;
		} else {
			return TRUE;
		}
		
	}

	// bind array to this object
	function reset()
	{

		
		foreach (get_object_vars($this) as $key=>$value) 
		{
			
			if(!preg_match('/^_/',$key))$this->$key = null;
		}	

	}	
	function bind($array)
	{
		foreach (get_object_vars($this) as $key=>$value) 
		{
			if (isset($array[$key])) 
			{
				$this->$key = $array[$key];
			}
		}
	}
	
	//check values in vars, should be overloaded
	//also clean values before checking
	function check()
	{
		return TRUE;
	}
	
	function confirm($wat='')
	{
		return cmstemplates::show('confirm','cmstemplates',array('wat'=>$wat,'id'=>$this->id));
	}	
	
	function delete($confirm=0,$wat='')
	{
		
		if($confirm && !isset($_POST['confirm']))
		{
			return $this->confirm($wat);
		}	
		
		
		$tk = $this->_tablekey;
		if( $this->$tk ) {
			
			$this->load($this->$tk);
			if(isset($this->priority) && $this->priority>=0)
			{
				
				$sql='UPDATE '.$this->_tablename.' SET `priority`=`priority`-1 WHERE `priority`>'.$this->priority;
				if(isset($this->pid))$sql.=' AND `pid`='.$this->pid;
				
				$rs = $this->_db->Execute($sql);
			}
			$sql = 	'DELETE FROM `'.$this->_tablename.'` WHERE `'.$this->_tablekey.'`=\''.$this->$tk.'\'';
			//echo $sql; exit;
			$rs = $this->_db->Execute($sql);
		} else {
			return FALSE;
		}
		if ($rs === FALSE) {
			$this->_error = $this->_db->ErrorMsg();
			return FALSE;
		} else {
			return TRUE;
		}
		
	}

	function on( $id = 0 , $field='status', $check=true)
	{
		if( $id ) {
			$this->load( $id );
		}
		$this->{$field} = 'on';
		return $this->save(false,$check);
	}

	function off( $id = 0 , $field='status',$check=true)
	{
		if( $id ) {
			$this->load( $id );
		}
		$this->{$field} = 'off';

		return $this->save(false,$check);
	}
	
	function down( $id = 0 )
	{
		if( $id ) 
		{
			$this->load( $id );
		}
		$search=$this->priority;

		$sql = 'SELECT `id`,`priority` FROM `'.$this->_tablename.'` WHERE `priority`>'.$search;
		if(isset($this->pid))
		{
			$sql .= ' AND `pid`='.$this->pid;
		}
		$sql .= ' ORDER BY `priority` ASC';

		$rs = $this->_db->Execute($sql);
		
		if($rs->recordCount())
		{
		$row = $rs->fetchRow();	
		$this->load($row['id']);
		$this->priority=$row['priority']-1;
		$this->save();
		
		$this->load( $id );
		$this->priority=$row['priority'];
		
		return $this->save();
		}
		return;
	}
	
	function up( $id = 0 )
	{
		if( $id ) 
		{
			$this->load( $id);
		}
	
		$search = $this->priority;

		
		$sql = 'SELECT `id`,`priority` FROM `'.$this->_tablename.'` WHERE `priority`<'.$search;
		if(isset($this->pid))
		{
			$sql .= ' AND `pid`='.$this->pid;
		}
		$sql .= ' ORDER BY `priority` DESC';

		$rs = $this->_db->Execute($sql);
		
		if($rs->recordCount())
		{
		$row=$rs->fetchRow();		
		$this->load($row['id']);
		$this->priority=$row['priority']+1;
		$this->save();
		
		$this->load( $id );
		$this->priority=$row['priority'];
		
		return $this->save();
		}
		
		return;
	}

}
?>