<?
class oscmscontactform extends EstrateDB
{
	var	$id;
	var	$subject;
	var $message;
	var	$firstname;
	var	$lastname;
	var $email;
    var $phone;
    var $organisation; 
    var $securityinfo;
    var $insert_time;
	

	
	function oscmscontactform( &$db )
	{
		EstrateDB::EstrateDB( $db );
		cmsconfig::load_contants('oscmscontactform');
		require_once( CMS_CURRENT_LANGUAGE.'.php' );
	}

	function check()
        {
                $this->bind($_POST);
        		$required=explode(',',CMS_CONTACTFORM_REQUIRED);
				
                $error = array();
                $errors = array();
                if(CMS_CONTACTFORM_CAPTCHA)
                {
                	
                if(!checkcaptcha()) 
                {
                return array(array(CAPTCHA_WRONGCODE),array()); //'Ongeldige beveiligingscode';
                }
                } 
                foreach ($required as $requirement)
                if( !$this->{$requirement} ) {
                        $error[] = constant  ( 'CONTACTFORM_'.strtoupper($requirement).'_ERROR' );
                        $errors[$requirement]=1;
                }
                
                

                if($this->email && !checkemail_format($this->email))
                {
                        /* check emailadres */
                        $error[] = CONTACTFORM_EMAIL_ERROR;
                        $errors['email']=1;
                }
                
                $this->insert_time = time();
                $this->securityinfo = getSecurityInfo();
                $this->securityinfo .= "\n".$_SERVER['SERVER_NAME'];
		return array($error,$errors);
	}
	
	function send()
	{
		$vars = get_object_vars( $this );
		$plaintext = cmstemplates::show('plaintext','oscmscontactform',$vars);
	

		return sendEmail(CMS_CONTACTFORM_EMAIL, '', '', $this->email, $this->subject, $plaintext);
	}	

	function show()
	{
		if(isset($_POST['sent']))
		{
		   list($error,$errors)=$this->check();
		   if(empty($error))
		   {
		   		if( CMS_CONTACTFORM_SAVE ) 
		   		{
		   		    
		   			
		   			$this->save();
		        }
		   		if( CMS_CONTACTFORM_EMAIL )  $this->send();
		   	    $vars['response'] = CONTACTFORM_THANKS;
		   		$this->load(0);
		   }	
		   else 
		   {
		   $vars = get_object_vars( $this );
		   }
		}
		
		
		
		if(!empty($error))
		{
			$terrors = '';
	
			$terrorrow = cmstemplates::loadfile('errorrow',null);
			foreach ($error as $terror)
			{
				 $terrors .= cmstemplates::parse($terrorrow,array('error'=>$terror));
				 
			}	
			
			foreach ($errors as $error=>$v)
			{
				$vars[$error.'class'] = 'error';
			}	
			
			$vars['errors'] = cmstemplates::show('errors',null,array('errors'=>$terrors));
		}

		$required=explode(',',CMS_CONTACTFORM_REQUIRED);

		foreach ($required as $requirement)
		{
			$vars[$requirement.'required'] = CONTACTFORM_REQUIREDSIGN;
		}
			
		if(CMS_CONTACTFORM_CAPTCHA)
        {
        	$vars['captcha'] = cmstemplates::show('captchafield',null);
        }	
		return cmstemplates::show('contactform','oscmscontactform',$vars);	
	}
}
?>